History of Previous Changes

> This page details the changes made in previous versions only. Current changes are detailed in Changes .

> Changes sections are chronologically ordered from top (most recent) to bottom (least recent)

> # Version 2.12

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> Java 8 support

> Now, JMeter 2.12 is compliant with Java 8.

> New Elements

> Critical Section Controller

> The Critical Section Controller allow to serialize the execution of a section in your tree. Only one instance of the section will be executed at the same time during the test.

> DNS Cache Manager

> The new configuration element DNS Cache Manager (see Bug 56841 ) improves the testing of:

> - CDN (Content Delivery Network)
> - DNS load balancing.
> - Load Balancers like Amazon Elastic Load Balancer

> Core Improvements

> Smarter Recording of Http Test Plans

> Test Script Recorder has been improved in many ways

> - Better matching of Variables in Requests, making Test Script Recorder variabilize your sampler during recording more versatile
> - Ability to filter from View Results Tree the Samples that are excluded from recording, this lets you concentrate on recorded Samplers analysis and not bother with useless Sample Results

> - Better defaults for recording, since this version Recorder will number created Samplers letting you find them much easily in View Results Tree. Grouping of Samplers under Transaction Controller will be smarter making all requests emitted by a web page be children as new Transaction Controller

> Support of Webdav requests

> You can now test against WebDav server using HttpClient4 Implementation of Http Request

> Better handling of embedded resources

> When download embedded resources is checked, JMeter now uses User Agent header to download or not resources embedded within conditionnal comments as per About conditional comments .

> Ability to customize Cache Manager (Browser cache simulation) handling of cached resources

> You can now configure the behaviour of JMeter when a resource is found in Cache, this can be controlled with cache_manager.cached_resource_mode property

> JMS Publisher / JMS Point-to-Point

> Add JMSPriority and JMSExpiration fields for these samplers.

> Mail Reader Sampler

> You can now specify the number of messages that want you retrieve (before all messages were retrieved). In addition, you can fetch only the message header now.

> SMTP Sampler

> Adding the Connection timeout and the Read timeout to the SMTP Sampler.

> Synchronizing Timer

> Adding a timeout to define the maximum time to waiting of the group of virtual users.

> Performance improvements

> A big improvement in performances of Functions has been made by lifting useless synchronization. It concerns all functions except __StringFromFile, __XPath and __BeanShell, see Bug 57114

> __jexl2 performances have been improved to avoid contention point, see Bug 56708

> GUI Improvements

> Undo/Redo support

> Undo / Redo has been introduced and allows user to undo/redo changes made on Test Plan Tree. This feature (ALPHA MODE) is disabled by default, to enable it set property undo.history.size=25

> View Results Tree

> Improve the ergonomics of View Results Tree by changing placement of Renderers and allowing custom ordering (with the property view.results.tree.renderers_order ).

> Response Time Graph

> Adding the ability for the Response Time Graph listener to save/restore format its settings in/from the jmx file.

> Log Viewer

> Starting with this version, the last lines of JMeter's log file (jmeter.log) can be viewed directly in GUI by clicking on Warning icon in the upper right corner. This will unfold the Log Viewer panel and show logs.

> File Opening

> Now, "Open File dialog" uses last opened file folder as start folder, see Bug 52707

> Known bugs

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show 0 (see Bug 55510 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(...) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - With Java 1.6 and Gnome 3 on Linux systems, the JMeter menu may not work correctly (shift between mouse's click and the menu). This is a known Java bug (see Bug 54477 ). A workaround is to use a Java 7 runtime (OpenJDK or Oracle JDK).
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629 . A workaround is to use a Java 7 update 40 runtime which fixes this issue.
> - You may encounter the following error: java.security.cert.CertificateException: Certificates does not conform to algorithm constraints if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like md2WithRSAEncryption) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 7 version u16 (MD2) and version u40 (Certificate size lower than 1024 bits), and Java 8 too.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java jdk.certpath.disabledAlgorithms property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.

> Incompatible changes

> - Since JMeter 2.12, active threads in all thread groups and active threads in current thread group are saved by default to CSV or XML results, see Bug 57025 . This is usually the expected behaviour as you want to have the number of running threads during the test. But if you want to revert to previous behaviour, set property jmeter.save.saveservice.thread_counts=false
> - Since JMeter 2.12, Mail Reader Sampler will show 1 for number of samples instead of number of messages retrieved, see Bug 56539
> - Since JMeter 2.12, when using Cache Manager, if resource is found in cache no SampleResult will be created, in previous version a SampleResult with empty content and 204 return code was returned, see Bug 54778 . You can choose between different ways to handle this case, see cache_manager.cached_resource_mode in jmeter.properties.
> - Since JMeter 2.12, Log Viewer will no more clear logs when closed and will have logs available even if closed. See Bug 56920 . Read Hints and Tips > Enabling Debug logging for details on configuring this component.

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 55998 - HTTP recording ? Replacing port value by user defined variable does not work
> - Bug 56178 - keytool error: Invalid escaped character in AVA: - some characters must be escaped
> - Bug 56222 - NPE if jmeter.httpclient.strict_rfc2616=true and location is not absolute
> - Bug 56263 - DefaultSamplerCreator should set BrowserCompatible Multipart true
> - Bug 56231 - Move redirect location processing from HC3/HC4 samplers to HTTPSamplerBase#followRedirects()
> - Bug 56207 - URLs get encoded on redirects in HC3.1 & HC4 samplers
> - Bug 56303 - The width of target controller's combo list should be set to the current panel size, not on label size of the controllers
> - Bug 54778 - HTTP Sampler should not return 204 when resource is found in Cache, make it configurable with new property cache_manager.cached_resource_mode

> ### Other Samplers

> - Bug 55977 - JDBC pool keepalive flooding
> - Bug 55999 - Scroll bar on jms point-to-point sampler does not work when content exceeds display
> - Bug 56198 - JMSSampler : NullPointerException is thrown when JNDI underlying implementation of JMS provider does not comply with Context.getEnvironment contract
> - Bug 56428 - MailReaderSampler - should it use mail.pop3s.* properties?
> - Bug 46932 - Alias given in select statement is not used as column header in response data for a JDBC request.Based on report and analysis of Nicola Ambrosetti
> - Bug 56539 - Mail reader sampler: When Number of messages to retrieve is superior to 1, Number of samples should only show 1 not the number of messages retrieved
> - Bug 56809 - JMSSampler closes InitialContext too early. Contributed by Bradford Hovinen (hovinen at gmail.com)
> - Bug 56761 - JMeter tries to stop already stopped JMS connection and displays "The connection is closed"
> - Bug 57068 - No error thrown when negative duration is entered in Test Action
> - Bug 57078 - LagartoBasedHTMLParser fails to parse page that contains input with no type
> - Bug 57183 - JMSSampler: For input string: "" java.lang.NumberFormatException (for Expiration or Priority fields)

> ### Controllers

> - Bug 56243 - Foreach works incorrectly with indexes on subsequent iterations
> - Bug 56276 - Loop controller becomes broken once loop count evaluates to zero
> - Bug 56160 - StackOverflowError when using WhileController within IfController
> - Bug 56811 - "Start Next Thread Loop" in Result Status Action Handler or on Thread Group and "Go to next Loop iteration" in Test Action behave incorrectly with TransactionController that has "Generate Parent Sampler" checked

> ### Listeners

> - Bug 56706 - SampleResult#getResponseDataAsString() does not use encoding in response body impacting PostProcessors and ViewResultsTree. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57052 - ArithmeticException: / by zero when sampleCount is equal to 0

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 56162 - HTTP Cache Manager should not cache PUT/POST etc.
> - Bug 56227 - AssertionGUI : NPE in assertion on mouse selection
> - Bug 41319 - URLRewritingModifier : Allow Parameter value to be url encoded

> ### Functions

> ### I18N

> - Bug 56111 - "comments" in german translation is not correct

> ### General

> - Bug 56059 - Older TestBeans incompatible with 2.11 when using TextAreaEditor
> - Bug 56080 - Conversion error com.thoughtworks.xstream.converters.ConversionException with Java 8 Early Access Build
> - Bug 56182 - Can't trigger bsh script using bshclient.jar; socket is closed unexpectedly
> - Bug 56360 - HashTree and ListedHashTree fail to compile with Java 8
> - Bug 56419 - JMeter silently fails to save results
> - Bug 56662 - Save as xml in a listener is not remembered
> - Bug 56367 - JMeter 2.11 on maven central triggers a not existing dependency rsyntaxtextarea 2.5.1, upgrade to 2.5.3
> - Bug 56743 - Wrong mailing list archives on mail2.xml. Contributed by Felix Schumacher (felix.schumacher at internetallee.de)
> - Bug 56763 - Removing the Oracle icons, not used by JMeter (and missing license)
> - Bug 54100 - Switching languages fails to preserve toolbar button states (enabled/disabled)
> - Bug 54648 - JMeter GUI on OS X crashes when using CMD+C (keyboard shortcut or UI menu entry) on an element from the tree
> - Bug 56962 - JMS GUIs should disable all fields affected by jndi.properties checkbox
> - Bug 57061 - Save as Test Fragment fails to clone deeply selected node. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57075 - BeanInfoSupport.MULTILINE attribute is not processed
> - Bug 57076 - BooleanPropertyEditor#getAsText() must return a value that is in getTags()
> - Bug 57088 - NPE in ResultCollector.testEnded

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 55959 - Improve error message when Test Script Recorder fails due to I/O problem
> - Bug 52013 - Test Script Recorder's Child View Results Tree does not take into account Test Script Recorder excluded/included URLs. Based on report and analysis of James Liang
> - Bug 56119 - File uploads fail every other attempt using timers. Enable idle timeouts for servers that don't send Keep-Alive headers.
> - Bug 56272 - MirrorServer should support query parameters for status and redirects
> - Bug 56772 - Handle IE Conditional comments when parsing embedded resources
> - Bug 57026 - HTTP(S) Test Script Recorder : Better default settings. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57107 - Patch proposal: Add DAV verbs to HTTP Sampler. Contributed by Philippe Jung (apache at famille-jung.fr)
> - Bug 56357 - Certificates does not conform to algorithm constraints: Adding a note to indicate how to remove of the Java installation these new security constraints

> ### Other samplers

> - Bug 56033 - Add Connection timeout and Read timeout to SMTP Sampler
> - Bug 56429 - MailReaderSampler - no need to fetch all Messages if not all wanted
> - Bug 56427 - MailReaderSampler enhancement: read message header only
> - Bug 56510 - JMS Publisher/Point to Point: Add JMSPriority and JMSExpiration

> ### Controllers

> - Bug 56728 - New Critical Section Controller to serialize blocks of a Test. Based partly on a patch contributed by Mikhail Epikhin(epihin-m at yandex.ru)
> - Bug 57145 - RandomController : Use ThreadLocalRandom instead of Random for better performances

> ### Listeners

> - Bug 56228 - View Results Tree : Improve ergonomy by changing placement of Renderers and allowing custom ordering
> - Bug 56349 - "summary" is a bad name for a Generate Summary Results component, documentation clarified
> - Bug 56769 - Adds the ability for the Response Time Graph listener to save/restore format settings in/from the jmx file
> - Bug 57025 - SaveService : Better defaults, save thread counts by default

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 56691 - Synchronizing Timer : Add timeout on waiting
> - Bug 56701 - HTTP Authorization Manager/ Kerberos Authentication: add port to SPN when server port is neither 80 nor 443. Based on patches from Dan Haughey (dan.haughey at swinton.co.uk) and Felix Schumacher (felix.schumacher at internetallee.de)
> - Bug 56841 - New configuration element: DNS Cache Manager to improve the testing of CDN. Based on patch from Dzmitry Kashlach (dzmitrykashlach at gmail.com), and contributed by BlazeMeter Ltd.
> - Bug 52061 - Allow access to Request Headers in Regex Extractor. Based on patch from Dzmitry Kashlach (dzmitrykashlach at gmail.com), and contributed by BlazeMeter Ltd.

> ### Functions

> - Bug 56708 - __jexl2 doesn't scale with multiple CPU cores. Based on analysis and patch contributed by Mikhail Epikhin(epihin-m at yandex.ru)
> - Bug 57114 - Performance : Functions that only have values as instance variable should not synchronize execute. Based on analysis by Ubik Load Pack support and Vladimir Sitnikov, patch contributed by Vladimir Sitnikov (sitnikov.vladimir at gmail.com)

> ### I18N

> ### General

> - Bug 21695 - Unix jmeter start script assumes it is on PATH, not a link
> - Bug 56292 - Add the check of the Java's version in startup files and disable some options when is Java v8 engine
> - Bug 56298 - JSR223 language display does not show which engine will be used
> - Bug 56455 - Batch files: drop support for non-NT Windows shell scripts
> - Bug 52707 - Make Open File dialog use last opened file folder as start folder. Based on patch from Dzmitry Kashlach (dzmitrykashlach at gmail.com), and contributed by BlazeMeter Ltd.
> - Bug 56807 - Ability to force flush of ResultCollector file. Contributed by Andrey Pohilko (apc4 at ya.ru)
> - Bug 56921 - Templates : Improve Recording template to ignore embedded resources case and URL parameters. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 42248 - Undo-redo support on Test Plan tree modification. Developed by Andrey Pohilko (apc4 at ya.ru) and contributed by BlazeMeter Ltd. Additional contribution by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 56920 - LogViewer : Make it receive all log events even when it is closed. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57083 - simplified the CachedResourceMode enum. Contributed by Graham Russel (graham at ham1.co.uk)
> - Bug 57082 - ComboStringEditor : Added hashCode to an inner class which overwrote equals. Contributed by Graham Russel (graham at ham1.co.uk)
> - Bug 57081 - Updating checkstyle to only check for tabs in java, xml, xsd, dtd, htm, html and txt files (not images!). Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 56178 - Really replace backslashes in user name before generating proxy certificate. Contributed by Graham Russel (graham at ham1.co.uk)
> - Bug 57084 - Close socket after usage in BeanShellClient. Contributed by Graham Russel (graham at ham1.co.uk)

> Non-functional changes

> - Bug 57117 - Increase the default cipher for HTTPS Test Script Recorder from SSLv3 to TLS
> - Updated to commons-lang3 3.3.2 (from 3.1)
> - Updated to commons-codec 1.9 (from 1.8)
> - Updated to commons-logging 1.2 (from 1.1.3)
> - Updated to tika 1.6 (from 1.4)
> - Updated to xercesImpl 2.11.0 (from 2.9.1)
> - Updated to xml-apis 1.4.01 (from 1.3.04)
> - Updated to xstream 1.4.8 (from 1.4.4)
> - Updated to jodd 3.6.1 (from 3.4.10)
> - Updated to rsyntaxtextarea 2.5.3 (from 2.5.1)
> - Updated xalan and serializer to 2.7.2 (from 2.7.1)
> - Updated to jsoup-1.8.1.jar (from 1.7.3)

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - James Liang (jliang at andera.com)
> - Emmanuel Bourg (ebourg at apache.org)
> - Nicola Ambrosetti (ambrosetti.nicola at gmail.com)
> - Ubik Load Pack
> - Mikhail Epikhin (epihin-m at yandex.ru)
> - Dan Haughey (dan.haughey at swinton.co.uk)
> - Felix Schumacher (felix.schumacher at internetallee.de)
> - Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - Andrey Pohilko (apc4 at ya.ru)
> - Bradford Hovinen (hovinen at gmail.com)
> - BlazeMeter Ltd.
> - Graham Russell (graham at ham1.co.uk)
> - Philippe Jung (apache at famille-jung.fr)
> - Vladimir Sitnikov (sitnikov.vladimir at gmail.com)
> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:
> - Oliver LLoyd (email at oliverlloyd.com) for his help on Bug 56119
> - Vladimir Ryabtsev (greatvovan at gmail.com) for his help on Bug 56243 and Bug 56276
> - Adrian Speteanu (asp.adieu at gmail.com) and Matt Kilbride (matt.kilbride at gmail.com) for their feedback and tests on Bug 54648
> - Shmuel Krakower (shmulikk at gmail.com) for his tests and reports on Undo/Redo feature
> Apologies if we have omitted anyone else.

> # Version 2.11

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> HTTP(S) Test Script Recorder improvements

> Following improvements have been made since major changes introduced in JMeter 2.10 on HTTP(S) Test Script Recorder:

> - Better detection of missing or invalid configuration of keytool utility
> - New system property keytool.directory (see system.properties) lets you configure directory containing keytool in case on non-standard installation

> JMS Publisher/Point to Point : Add ability to set typed values in JMS header properties

> In the samplers JMS Publisher and JMS Point-to-Point, you can now set up the class of values for the JMS header properties. Previously only String was possible.

> View Results Tree : Add an XPath Tester

> In View Results Tree listener, a new XPath tester can be used to test XPATH expressions.

> Ability to choose the client alias for the cert key in JsseSslManager such that Mutual SSL auth testing can be made more flexible

> When testing client based certificate authentications you have now better control on certificate you use through a new field "Variable name holding certificate alias", this field lets you select the certificate you want to send to server to authenticate. You can use a CSV Data Set as a holder for the variable value.

> Add a "Save as Test Fragment" option

> In the file menu, a new option allow to save a group of elements as a Test fragment.

> Summariser is be enabled by default in Non GUI mode

> When you run JMeter from command line, now JMeter displays some statistics from the Summariser mode.

> Transaction Controller:Change default property "Include duration of timer..." for newly created element

> Starting from 2.11, Transaction Controller is configured by default to exclude processing time of pre/post processors as long as timers pause.

> Known bugs

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show 0 (see Bug 55510 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - With Java 1.6 and Gnome 3 on Linux systems, the JMeter menu may not work correctly (shift between mouse's click and the menu). This is a known Java bug (see Bug 54477 ). A workaround is to use a Java 7 runtime (OpenJDK or Oracle JDK).
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629 . A workaround is to use a Java 7 update 40 runtime which fixes this issue.

> Incompatible changes

> - When creating a new Transaction Controller, property "Include duration of timer and pre-post processors in generated sample" will be unchecked starting from version 2.11
> - In Non GUI mode, since 2.11 summariser is enabled with a 30 seconds frequency
> - JMeter is more lenient with redirect handling and relaxes on RFC2616 by allowing relative locations. See property "jmeter.httpclient.strict_rfc2616" in jmeter.properties to change this behaviour, see Bug 55717
> - When creating a new Response Assertion, property "Pattern Matching Rules" now defaults to Substring starting from version 2.11

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 55815 - Proxy#getDomainMatch does not handle wildcards correctly
> - Bug 55717 - Bad handling of Redirect when URLs are in relative format by HttpClient4 and HttpClient3.1

> ### Other Samplers

> - Bug 55685 - OS Sampler: timeout option don't save and restore correctly value and don't init correctly timeout

> ### Controllers

> - Bug 55816 - Transaction Controller with "Include duration of timer..." unchecked does not ignore processing time of last child sampler

> ### Listeners

> - Bug 55826 - Unsynchronised concurrent accesses to list in field RespTimeGraphVisualizer.internalList

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 55694 - Assertions and Extractors : Avoid NullPointerException when scope is variable and variable is missing
> - Bug 55721 - HTTP Cache Manager - no-store directive is wrongly interpreted

> ### Functions

> - Bug 55871 - Wrong result with intSum() function when a space character is present before/after the number. Contributed by Milamber based on a proposal by James Liang.

> ### I18N

> ### General

> - Bug 55739 - Remote Test : Total threads in GUI mode shows invalid total number of threads

> Improvements

> ### HTTP Samplers and Proxy

> ### Other samplers

> - Bug 55589 - JMS Publisher/Point to Point : Add ability to set typed values in JMS header properties.

> ### Controllers

> - Bug 55854 - Transaction Controller:Change default property "Include duration of timer..." for newly created element

> ### Listeners

> - Bug 55610 - View Results Tree : Add an XPath Tester

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 55908 - Response assertion : Change Pattern Matching Rules default to Substring on creation for better performances
> - Bug 54977 - Ability to choose the client alias for the cert key in JsseSslManager such that Mutual SSL auth testing can be made more flexible. Contributed by UBIK Load Pack (support at ubikloadpack.com)

> ### Functions

> ### I18N

> ### General

> - Bug 55693 - Add a "Save as Test Fragment" option
> - Bug 55753 - Improve FilePanel behaviour to start from the value set in Filename field if any. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55756 - HTTP Mirror Server : Add ability to set Headers
> - Bug 55852 - Be more lenient in parsing when charset value is surrounded with single quotes
> - Bug 55857 - Performance : AbstractProperty should test for emptiness to avoid Exception throwing
> - Bug 55858 - Startup Performance : On Startup, BeanInfoSupport should test for key availability instead of throwing
> - Bug 55865 - Performance :Disable stale check by default in HttpClient 4 and 3.1
> - Bug 55512 - Summariser should be enabled by default in Non GUI mode

> Non-functional changes

> - Updated to rsyntaxtextarea-2.5.1.jar (from 2.5.0)
> - Updated to jodd-core-3.4.9.jar from (3.4.8) and jodd-lagarto-3.4.9.jar (from 3.4.9)
> - Updated to jsoup-1.7.3.jar (from 1.7.2)
> - Updated to mail-1.5.0-b01 (from 1.4.4)
> - Updated to mongo-java-driver-2.11.3 (from 2.11.2)

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - James Liang (jliang at andera.com)
> - UBIK Load Pack (support at ubikloadpack.com)
> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:
> - John Natsioulas (john_natsioulas at yahoo.com.au)
> - Antonio Gomes Rodrigues (ra0077 at gmail.com)
> Apologies if we have omitted anyone else.

> # Version 2.10

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> Core Improvements

> New Performance improvements

> - A Huge performance improvement has been made on High Throughput Tests (no pause), see Bug 54777
> - An issue with unnecessary SSL Context reset has been fixed which improves performances of pure HTTP tests, see Bug 55023
> - Important performance improvement in parsing of Embedded resource in HTML pages thanks to a switch to JODD/Lagarto HTML Parser, see Bug 55632

> New CSS/JQuery Tester in View Tree Results

> A new CSS/JQuery Tester in View Tree Results that makes CSS/JQuery Extractor a first class citizen in JMeter, you can now test your expressions very easily

> Many improvements in HTTP(S) Recording have been made

> The "HTTP Proxy Server" test element has been renamed as "HTTP(S) Test Script Recorder".

> - Better recording of HTTPS sites, embedded resources using subdomains will more easily be recorded when using JDK 7. See Bug 55507 . See updated documentation: HTTP(S) Test Script Recorder
> - Redirection are now more smartly detected by HTTP Proxy Server, see Bug 55531
> - Many fixes on edge cases with HTTPS have been made, see Bug 55502 , Bug 55504 , Bug 55506
> - Many encoding fixes have been made, see Bug 54482 , Bug 54142 , Bug 54293

> You can now load test MongoDB through new MongoDB Source Config

> Kerberos authentication has been added to Auth Manager

> Device can now be used in addition to source IP address

> You can now do functional testing of MongoDB scripts through new MongoDB Script

> Timeout has been added to OS Process Sampler

> Query timeout has been added to JDBC Request

> New functions (__urlencode and __urldecode) are now available to encode/decode URL encoded chars

> Continuous Integration is now eased by addition of a new flag that forces NON-GUI JVM to exit after test end

> See jmeter property:

> `jmeterengine.force.system.exit`

> HttpSampler now allows DELETE Http Method to have a body (works for HC4 and HC31 implementations). This allows for example to test Elastic Search APIs

> 2 implementations of HtmlParser have been added to improve Embedded resources parsing

> You can choose the implementation to use for parsing Embedded resources in HTML pages: See jmeter.properties and look at property "htmlParser.className".

> - org.apache.jmeter.protocol.http.parser.LagartoBasedHtmlParser for optimal performances
> - org.apache.jmeter.protocol.http.parser.JSoupBasedHtmlParser for most accurate parsing and functional testing

> Distributed testing has been improved

> - Number of threads on each node are now reported to controller.

> - Performance improvement on BatchSampleSender( Bug 55423 )
> - Addition of 2 SampleSender modes (StrippedAsynch and StrippedDiskStore), see jmeter.properties

> ModuleController has been improved to better handle changes to referenced controllers

> Improved class loader configuration, see

> - New property "plugin_dependency_paths" for plugin dependencies
> - Properties "search_paths", "user.classpath" and "plugin_dependency_paths" now automatically add all jars from configured directories

> Best-practices section has been improved, ensure you read it to get the most out of JMeter

> See Best Practices

> GUI and ergonomy Improvements

> New Templates feature that allows you to create test plan from existing template or merge template into your Test Plan

> Workbench can now be saved

> Syntax color has been added to scripts elements (BeanShell, BSF, and JSR223), MongoDB and JDBC elements making code much more readable and allowing UNDO/REDO through CTRL+Z/CTRL+Y

> BSF Sampler with syntax color

> JSR223 Pre Processor with syntax color

> Better editors are now available for Test Elements with large text content, like HTTP Sampler, and JMS related Test Element providing line numbering and allowing UNDO/REDO through CTRL+Z/CTRL+Y

> JMeter GUI can now be fully Internationalized, all remaining issues have been fixed

> ##### Currently French has all its labels translated. Other languages are partly translated, feel free to contribute translations by reading Localisation (Translator's Guide)

> Moving elements in Test plan has been improved in many ways

> ##### Drag and drop of elements in Test Plan tree is now much easier and possible on multiple nodes

> Note that due to this bug in Java , you cannot drop a node after last node. The workaround is to drop it before this last node and then Drag and Drop the last node before the one you just dropped.

> ##### New shortcuts have been added to move elements in the tree.

> (alt + Arrow Up) and (alt + Arrow Down) move the element within the parent node
> (alt + Arrow Left) and (alt + Arrow Right) move the element up and down in the tree depth

> Response Time Graph Y axis can now be scaled

> JUnit Sampler gives now more details on configuration errors

> Known bugs

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).
> - Webservice sampler does not consider the HTTP response status to compute the status of a response, thus a response 500 containing a non empty body will be considered as successful, see Bug 54006 . To workaround this issue, ensure you always read the response and add a Response Assertion checking text inside the response.
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, these only apply to a locally run test; they do not include any threads started on remote systems when using client-server mode, (see Bug 54152 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - With Java 1.6 and Gnome 3 on Linux systems, the JMeter menu may not work correctly (shift between mouse's click and the menu). This is a known Java bug (see Bug 54477 ). A workaround is to use a Java 7 runtime (OpenJDK or Oracle JDK).
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629 . A workaround is to use a Java 7 update 40 runtime which fixes this issue.

> Incompatible changes

> - SMTP Sampler now uses eml file subject if subject field is empty
> - With this version autoFlush has been turned off on PrintWriter in charge of writing test results. This results in improved throughput for intensive tests but can result in more test data loss in case of JMeter crash (extremely rare). To revert to previous behaviour set `jmeter.save.saveservice.autoflush` property to `true` .
> - Shortcut for Function Helper Dialog is now CTRL+SHIFT+F1 (CMD + SHIFT + F1 for Mac OS) . The original key sequence (Ctrl+F1) did not work in some locations (it is consumed by the Java Swing ToolTipManager). It was therefore necessary to change the shortcut.
> - Webservice (SOAP) Request has been removed by default from GUI as Element is deprecated. (Use HTTP Request with Body Data , see also the Template Building a SOAP Webservice Test Plan ), if you need to show it, see property `not_in_menu` in jmeter.properties
> - Transaction Controller now sets Response Code of Generated Parent Sampler (if Generated Parent Sampler is checked) to response code of first failing child in case of failure of one of the children, in previous versions Response Code was empty.
> - In previous versions, IncludeController could run Test Elements located inside a Thread Group , this behaviour ( which was not documented ) ould result in weird behaviour, it has been removed in this version (see Bug 55464 ). The correct way to include Test Elements is to use Test Fragment as stated in documentation of Include Controller .
> - The retry count for the HttpClient 3.1 and HttpClient 4.x samplers has been changed to 0 . Previously the default was 1, which could cause unexpected additional traffic.
> - Starting with this version, the HTTP(S) Test Script Recorder tries to detect when a sample is the result of a previous redirect. If the current response is a redirect, JMeter will save the redirect URL. When the next request is received, it is compared with the saved redirect URL and if there is a match, JMeter will disable the generated sample. To revert to previous behaviour, set the property `proxy.redirect.disabling=false`
> - Starting with this version, in HTTP(S) Test Script Recorder if Grouping is set to Put each group in a new Transaction Controller , the Recorder will create Transaction Controller instances with Include duration of timer and pre-post processors in generated sample set to false. This default value reflect more accurately response time.
> - `__escapeOroRegexpChars` function (which escapes ORO reserved characters) no longer trims the value (see Bug 55328 )
> - The commons-lang-2.6.jar has been removed from embedded libraries in `jmeter/lib` folder as it is not needed by JMeter at run-time (it is only used by Apache Velocity for generating documentation). If you use any plugin or third-party code that depends on it, you need to add it in `jmeter/lib` folder

> Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 54627 - JMeter Proxy GUI: Type of sampler setting takes the whole screen when there are samplers with long names.
> - Bug 54629 - HTMLParser does not extract <object> tag urls.
> - Bug 55023 - SSL Context reuse feature (51380) adversely affects non-ssl request performance/throughput. based on analysis by Brent Cromarty (brent.cromarty at yahoo.ca)
> - Bug 55092 - Log message "WARN - jmeter.protocol.http.sampler.HTTPSamplerBase: Null URL detected (should not happen)" displayed when embedded resource URL is malformed.
> - Bug 55161 - Useless processing in SoapSampler.setPostHeaders. Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 54482 - HC fails to follow redirects with non-encoded chars.
> - Bug 54142 - HTTP Proxy Server throws an exception when path contains "|" character.
> - Bug 55388 - HC3 does not allow IP Source field to override httpclient.localaddress.
> - Bug 55450 - HEAD redirects should remain as HEAD
> - Bug 55455 - HTTPS with HTTPClient4 ignores cps setting
> - Bug 55502 - Proxy generates empty http:/ entries when recording
> - Bug 55504 - Proxy incorrectly issues CONNECT requests when browser prompts for certificate override
> - Bug 55506 - Proxy should deliver failed requests to any configured Listeners
> - Bug 55545 - HTTP Proxy Server GUI should not allow both Follow and Auto redirect to be selected

> ### Other Samplers

> - Bug 54913 - JMSPublisherGui incorrectly restores its state. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 55027 - Test Action regression, duration value is not recorded (nightly build).
> - Bug 55163 - BeanShellTestElement fails to quote string when calling testStarted(String)/testEnded(String).
> - Bug 55349 - NativeCommand hangs if no input file is specified and the application requests input.
> - Bug 55462 - System Sampler should not change the sampler label if a sample fails

> ### Controllers

> - Bug 54467 - Loop Controller: compute loop value only once per parent iteration.
> - Bug 54985 - Make Transaction Controller set Response Code of Generated Parent Sampler to response code of first failing child in case of failure of one of its children. Contributed by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 54950 - ModuleController : Changes to referenced Module are not taken into account if changes occur after first run and referenced node is disabled.
> - Bug 55201 - ForEach controller excludes start index and includes end index (clarified documentation).
> - Bug 55334 - Adding Include Controller to test plan (made of Include Controllers) without saving TestPlan leads to included code not being taken into account until save.
> - Bug 55375 - StackOverflowError with ModuleController in Non-GUI mode if its name is the same as the target node.
> - Bug 55464 - Include Controller running included thread group

> ### Listeners

> - Bug 54589 - View Results Tree have a lot of Garbage characters if html page uses double-byte charset.
> - Bug 54753 - StringIndexOutOfBoundsException at SampleResult.getSampleLabel() if key_on_threadname=false when using Statistical mode.
> - Bug 54685 - ArrayIndexOutOfBoundsException if "sample_variable" is set in client but not server.
> - Bug 55111 - ViewResultsTree: text not refitted if vertical scrollbar is required. Contributed by Milamber

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 54540 - "HTML Parameter Mask" are not marked deprecated in the IHM.
> - Bug 54575 - CSS/JQuery Extractor : Choosing JODD Implementation always uses JSOUP.
> - Bug 54901 - Response Assertion GUI behaves weirdly.
> - Bug 54924 - XMLAssertion uses JMeter JVM file.encoding instead of response encoding and does not clean threadlocal variable.
> - Bug 53679 - Constant Throughput Timer bug with localization. Reported by Ludovic Garcia

> ### Functions

> - Bug 55328 - __escapeOroRegexpChars trims spaces.

> ### I18N

> - Bug 55437 - ComboStringEditor does not translate EDIT and UNDEFINED strings on language change
> - Bug 55501 - Incorrect encoding for French description of __char function. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)

> ### General

> - Bug 54504 - Resource string not found: [clipboard_node_read_error].
> - Bug 54538 - GUI: context menu is too big.
> - Bug 54847 - Cut & Paste is broken with tree multi-selection. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54870 - Tree drag and drop may lose leaf nodes (affected nightly build). Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 55056 - wasted work in Data.append(). Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 55129 - Change Javadoc generation per CVE-2013-1571, VU#225657.
> - Bug 55187 - Integer overflow when computing ONE_YEAR_MS in HTTP CacheManager.
> - Bug 55208 - JSR223 language entries are duplicated; fold to lower case.
> - Bug 55203 - TestBeanGUI - wrong language settings found.
> - Bug 55065 - Useless processing in Spline3.converge(). Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 55064 - Useless processing in ReportTreeListener.isValidDragAction(). Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 55242 - BeanShell Client jar throws exceptions after upgrading to 2.8.
> - Bug 55288 - JMeter should default to 0 retries for HTTP requests.
> - Bug 55405 - ant download_jars task fails if lib/api or lib/doc are missing. Contributed by Antonio Gomes Rodrigues.
> - Bug 55427 - TestBeanHelper should ignore properties not supported by GenericTestBeanCustomizer
> - Bug 55459 - Elements using ComboStringEditor lose the input value if user selects another Test Element
> - Bug 54152 - In distributed testing : activeThreads always show 0 in GUI and Summariser
> - Bug 55509 - Allow Plugins to be notified of remote thread number progression
> - Bug 55572 - Detail popup of parameter does not show a Scrollbar when content exceeds display
> - Bug 55580 - Help pane does not scroll to start for links
> - Bug 55600 - JSyntaxTextArea : Strange behaviour on first undo
> - Bug 55655 - NullPointerException when Remote stopping /shutdown all if one engine did not start correctly. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55657 - Remote and Local Stop/Shutdown buttons state does not take into account local / remote status

> Improvements

> ### HTTP Samplers and Proxy

> - HTTP Request: Small user interaction improvements in Row parameter Detail Box. Contributed by Milamber
> - Bug 55255 - Allow Body in HTTP DELETE method to support API that use it (like ElasticSearch).
> - Bug 53480 - Add Kerberos support to Http Sampler (HttpClient4). Based on patch by Felix Schumacher (felix.schumacher at internetallee.de)
> - Bug 54874 - Support device in addition to source IP address. Based on patch by Dan Fruehauf (malkodan at gmail.com)
> - Bug 55488 - Add .ico and .woff file extension to default suggested exclusions in proxy recorder. Contributed by Antonio Gomes Rodrigues
> - Bug 55525 - Proxy should support alias for keyserver entry
> - Bug 55531 - Proxy recording and redirects. Added code to disable redirected samples.
> - Bug 55507 - Proxy SSL recording does not handle external embedded resources well
> - Bug 55632 - Have a new implementation of htmlParser for embedded resources parsing with better performances
> - Bug 55653 - HTTP(S) Test Script Recorder should set TransactionController property "Include duration of timer and pre-post processors in generated sample" to false

> ### Other samplers

> - Bug 54788 - JMS Point-to-Point Sampler - GUI enhancements to increase readability and ease of use. Contributed by Bruno Antunes (b.m.antunes at gmail.com)
> - Bug 54798 - Using subject from EML-file for SMTP Sampler. Contributed by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 54759 - SSLPeerUnverifiedException using HTTPS , property documented.
> - Bug 54896 - JUnit sampler gives only "failed to create an instance of the class" message with constructor problems.
> - Bug 55084 - Add timeout support for JDBC Request. Contributed by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 55403 - Enhancement to OS sampler: Support for timeout
> - Bug 55518 - Add ability to limit number of cached PreparedStatements per connection when "Prepared Select Statement", "Prepared Update Statement" or "Callable Statement" query type is selected

> ### Controllers

> - Bug 54271 - Module Controller breaks if test plan is renamed.

> ### Listeners

> - Bug 54532 - Improve Response Time Graph Y axis scale with huge values or small values (< 1000ms). Add a new field to define increment scale. Contributed by Milamber based on patch by Luca Maragnani (luca.maragnani at gmail.com)
> - Bug 54576 - View Results Tree : Add a CSS/JQuery Tester.
> - Bug 54777 - Improve Performance of default ResultCollector. Based on patch by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 55389 - Show IP source address in request data

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 54789 - XPath Assertion - GUI enhancements to increase readability and ease of use.

> ### Functions

> - Bug 54991 - Add functions to encode/decode URL encoded chars (__urlencode and __urldecode). Contributed by Milamber.

> ### I18N

> - Bug 55241 - Need GUI Editor to process fields which are based on Enums with localised display strings
> - Bug 55440 - ComboStringEditor should allow tags to be language dependent
> - Bug 55432 - CSV Dataset Config loses sharing mode when switching languages

> ### General

> - Bug 54584 - MongoDB plugin. Based on patch by Jan Paul Ettles (janpaulettles at gmail.com)
> - Bug 54669 - Add flag forcing non-GUI JVM to exit after test. Contributed by Scott Emmons
> - Bug 42428 - Workbench not saved with Test Plan. Contributed by Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - Bug 54825 - Add shortcuts to move elements in the tree. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54834 - Improve Drag & Drop in the jmeter tree. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54839 - Set the application name on Mac. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54841 - Correctly handle the quit shortcut on Mac Os (CMD-Q). Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54844 - Set the application icon on Mac Os. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54864 - Enable multi selection drag & drop in the tree without having to start dragging before releasing Shift or Control. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54945 - Add Shutdown Hook to enable trapping kill or CTRL+C signals.
> - Bug 54990 - Download large files avoiding outOfMemory.
> - Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55172 - Provide plugins a way to add Top Menu and menu items.
> - Bug 55202 - Add syntax color for scripts elements (BeanShell, BSF, and JSR223) and JDBC elements with RSyntaxTextArea. Contributed by Milamber based on patch by Marko Vlahovic (vlahovic74 at gmail.com)
> - Bug 55175 - HTTPHC4Impl refactoring to allow better inheritance.
> - Bug 55236 - Templates - provide button to reload template details.
> - Bug 55237 - Template system should support relative fileName entries.
> - Bug 55423 - BatchSampleSender: Reduce locking granularity by moving listener.processBatch outside of synchronized block
> - Bug 55424 - Add Stripping to existing SampleSenders
> - Bug 55451 - Test Element GUI with JSyntaxTextArea scroll down when text content is long enough to add a Scrollbar
> - Bug 55513 - StreamCopier cannot be used with System.err or System.out as it closes the output stream
> - Bug 55514 - SystemCommand should support arbitrary input and output streams
> - Bug 55515 - SystemCommand should support chaining of commands
> - Bug 55606 - Use JSyntaxtTextArea for Http Request, JMS Test Elements
> - Bug 55651 - Change JMeter application icon to Apache plume icon

> Non-functional changes

> - Updated to jsoup-1.7.2
> - Bug 54776 - Update the dependency on Bouncy Castle to 1.48. Contributed by Emmanuel Bourg (ebourg at apache.org)
> - Updated to HttpComponents Client 4.2.6 (from 4.2.3)
> - Updated to HttpComponents Core 4.2.5 (from 4.2.3)
> - Updated to commons-codec 1.8 (from 1.6)
> - Updated to commons-io 2.4 (from 2.2)
> - Updated to commons-logging 1.1.3 (from 1.1.1)
> - Updated to commons-net 3.3 (from 3.1)
> - Updated to jdom-1.1.3 (from 1.1.2)
> - Updated to jodd-lagarto and jodd-core 3.4.8 (from 3.4.1)
> - Updated to junit 4.11 (from 4.10)
> - Updated to slf4j-api 1.7.5 (from 1.7.2)
> - Updated to tika 1.4 (from 1.3)
> - Updated to xmlgraphics-commons 1.5 (from 1.3.1)
> - Updated to xstream 1.4.4 (from 1.4.2)
> - Updated to BouncyCastle 1.49 (from 1.48)
> - Bug 54912 - JMeterTreeListener should use constants. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54903 - Remove the dependency on the Activation Framework. Contributed by Emmanuel Bourg (ebourg at apache.org)
> - Moved commons-lang (2.6) to lib/doc as it's only needed by Velocity.
> - Re-organised and simplified NOTICE and LICENSE files.
> - Bug 55411 - NativeCommand could be useful elsewhere. Copied code to o.a.jorphan.exec.
> - Bug 55435 - ComboStringEditor could be simplified to make most settings final
> - Bug 55436 - ComboStringEditor should implement ClearGui
> - Bug 55463 - Component.requestFocus() is discouraged; use requestFocusInWindow() instead
> - Bug 55486 - New JMeter Logo. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55548 - Tidy up use of TestElement.ENABLED; use TestElement.isEnabled()/setEnabled() throughout
> - Bug 55617 - Improvements to jorphan collection. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 55623 - Invalid/unexpected configuration values should not be silently ignored
> - Bug 55626 - Rename HTTP Proxy Server as HTTP(S) Test Script Recorder

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Bruno Antunes (b.m.antunes at gmail.com)
> - Emmanuel Bourg (ebourg at apache.org)
> - Scott Emmons
> - Mikhail Epikhin (epihin-m at yandex.ru)
> - Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - Luca Maragnani (luca.maragnani at gmail.com)
> - Milamber
> - Adrian Nistor (nistor1 at illinois.edu)
> - Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - UBIK Load Pack (support at ubikloadpack.com)
> - Benoit Wiart (benoit.wiart at gmail.com)
> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:
> - Immanuel Hayden (immanuel.hayden at gmail.com)
> - Danny Lade (dlade at web.de)
> - Brent Cromarty (brent.cromarty at yahoo.ca)
> - Wolfgang Heider (wolfgang.heider at racon.at)
> - Shmuel Krakower (shmulikk at gmail.com)
> Apologies if we have omitted anyone else.

> # Version 2.9

> ## New and Noteworthy

> ### Core Improvements:

> #### * A new Extractor that uses CSS or jquery-like selector syntax has been introduced, it allows using either JODD or JSOUP implementations

> Result: the title of the page in a JMeter variable

> #### * JMeter can now handle different types of documents (PDF, MsOffice files, Apache OpenOffice's files...) within different elements

> - Regular Expression Extractor, extract text from documents
> - Assertion Response, check text in documents
> - View Results Tree, view as a text the documents

> #### * A new Regex User Parameters Pre-Processor that enables injecting input parameter names and values using a reference extracted by Regular Expression Extractor from a previous response

> #### * TCP Sampler: new options

> TCP Sampler has been enhanced with new options to allow setting Close Connection , SO_LINGER and End of line(EOL) byte value

> #### * A new function __escapeOroRegexpChars(,) has been introduced quote ORO regexp meta characters

> #### * ForEach Controller: new fields

> ForEach Controller has now 2 new fields to control start and end of loop

> #### * Result Status Action Handler now has a new option to "Start next thread loop"

> #### * JMS Publisher: new option

> JMS Publisher can now send Bytes Messages

> #### * Memory and performance improvements

> Significant improvements have been done in this version on memory usage per Thread and CPU when more than one Post Processor is used as child of a Sampler

> JSR223 Elements (enable using Groovy, Scala... as scripting languages) have been improved to enable caching of Compilation results when scripts are passed in Text area

> Some configuration defaults have changed to improve performances by default(see Bug 54412 ), see description in New and Noteworthy section.

> - Distributed testing now uses MODE_STRIPPED_BATCH, which returns samples in batch mode (every 100 samples or every minute by default). Note also that MODE_STRIPPED_BATCH strips response data from SampleResult, so if you need it change to another mode (mode property in jmeter.properties)
> - Result data are now saved to CSV by default (jmeter.save.saveservice.output_format in jmeter.properties)

> #### * XPath Assertion now enables using a JMeter variable as input

> ### GUI and ergonomy Improvements:

> #### * Search feature has been improved to search within more internal fields of elements and expand search results

> #### * Copy/paste is now possible between 2 JMeter instances >= 2.9 version

> Copy element(s) from one JMeter instance:

> Paste element(s) into a second JMeter instance:

> #### * HTTP Header Manager

> Allow copy from clipboard to HeaderPanel, headers are supposed to be separated by new line and have the following form name:value

> #### * Module Controller

> Module Controller has been improved to better render referenced controller and expand it by clicking on a new button

> #### * HTTP Proxy Server

> HTTP Proxy Server now has a button to add a set of default exclusions for URL patterns, this list can be configured through property : proxy.excludes.suggested

> #### * Rendering of target controller has been improved in HTTP Proxy Server

> ### HTTP Proxy Server recording:

> * HTTP Proxy Server now automatically uses HTTP Request with Raw Post Body mode for samples that only have one unnamed argument (JSON, XML, GWT...)

> * HTTP Proxy Server does not force user to select the type of Sampler in HTTP Sampler Settings, this allows easier switch between implementations as Sampler do not have this information set anymore

> * SamplerCreator interface has been enriched to meet new requirements for plug-in providers

> * It is now possible to create binary sampler for x-www-form-urlencoded POST request by modifying proxy.binary.types property to add application/x-www-form-urlencoded

> * Improved timestamp format auto-detection when reading CSV files

> ## Known bugs

> The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).

> Webservice sampler does not consider the HTTP response status to compute the status of a response, thus a response 500 containing a non empty body will be considered as successful, see Bug 54006 . To workaround this issue, ensure you always read the response and add a Response Assertion checking text inside the response.

> Changing language can break part of the configuration of the following elements (see Bug 53679 ):

> - CSV Data Set Config (sharing mode will be lost)
> - Constant Throughput Timer (Calculate throughput based on will be lost)

> The numbers that appear to the left of the green box are the number of active threads / total number of threads, these only apply to a locally run test; they do not include any threads started on remote systems when using client-server mode, (see Bug 54152 ).

> Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>      [java] WARNING: Couldn't flush user prefs:
>      java.util.prefs.BackingStoreException:
>      java.lang.IllegalArgumentException: Not supported: indent-number

> This does not affect JMeter operation.

> ## Incompatible changes

> JMeter requires now a Java 6 runtime or higher.

> Some configuration defaults have changed to improve performances by default (see Bug 54412 ), see description in New and Noteworthy section.

> Webservice sampler now adds to request the headers that are set through Header Manager, these were previously ignored

> jdbcsampler.cachesize property has been removed, it previously limited the size of a per connection cache of Map < String, PreparedStatement > , it also limited the size of this map which held the PreparedStatement for SQL queries. This limitation provoked a bug Bug 53995 . It has been removed so now size of these 2 maps is not limited anymore. This change changes behaviour as starting from this version no PreparedStatement will be closed during the test.

> Starting with this version, there are some important changes on JSR223 Test Elements:

> - JSR223 Test Elements that have an invalid filename (not existing or unreadable) will make test fail instead of making the element silently work
> - In JSR223 Test Elements: responseCodeOk, responseMessageOK and successful are set before script is executed, if responseData is set it will not be overriden anymore by a toString() on script return value

> View Results Tree now considers response with missing content type as text.

> In remote Test mode, JMeter now exits in error if one of the remote engines cannot be configured, previously it started the test with available engines.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Don't log spurious warning messages when using concurrent pool embedded downloads with Cache Manager or CookieManager
> - Bug 54057 - Proxy option to set user and password at startup (-u and -a) not working with HTTPClient 4
> - Bug 54187 - Request tab does not show headers if request fails
> - Bug 53840 - Proxy Recording : Response message: URLDecoder: Illegal hex characters in escape (%) pattern - For input string: "" "
> - Bug 54351 - HC4 and URI fragments is failing

> ### Other Samplers

> - Bug 53997 - LDAP Extended Request: Escape ampersand (&), left angle bracket (<) and right angle bracket (>) in search filter tag in XML response data
> - Bug 53995 - AbstractJDBCTestElement shares PreparedStatement between multi-threads
> - Bug 54119 - HTTP 307 response is not redirected
> - Bug 54326 - AjpSampler send file in post throws FileNotFoundException
> - Bug 54331 - AjpSampler throws null pointer on GET request that are protected

> ### Controllers

> ### Listeners

> - Bug 54088 - The type video/f4m is text, not binary
> - Bug 54166 - ViewResultsTree could not render the HTML response: handle failure to parse HTML
> - Bug 54287 - Incorrect Timestamp in Response Time Graph when using a date with time in Date format field
> - Bug 54451 - Response Time Graph reports wrong times when the are many samples for same time
> - Bug 54459 - CSVSaveService does not handle date parsing very well

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 54058 - In HTTP Request Defaults, the value of field "Embedded URLs must match: is not saved if the check box "Retrieve All Embedded Resources" is not checked.
> - Bug 54375 - Regular Expression Extractor : When regex syntax is wrong, post processing is stopped

> ### Functions

> ### I18N

> ### General

> - Bug 53975 - Variables replacement doesn't work with option "Delay thread creation until needed"
> - Bug 54055 - View Results tree: = signs are stripped from parameter values at HTTP tab
> - Bug 54129 - Search Feature does not find text although existing in elements
> - Bug 54023 - Unable to start JMeter from a root directory and if the full path of JMeter installation contains one or more spaces (Unix/linux)
> - Bug 54172 - Duplicate shortcut key not working and CTRL+C / CTRL+V / CTRL+V do not cancel default event
> - Bug 54057 - Proxy option to set user and password at startup (-u and -a) not working with HTTPClient 4
> - Bug 54267 - Start Next Thread Loop setting doesn't work in custom thread groups
> - Bug 54413 - DataStrippingSampleSender returns 0 for number of bytes of any response

> ## Improvements

> ### HTTP Samplers

> - Bug 54185 - Allow query strings in paths that start with HTTP or HTTPS

> ### Other samplers

> - Bug 54004 - Webservice Sampler : Allow adding headers to request with Header Manager
> - Bug 54106 - JSR223TestElement should check for file existence when a filename is set instead of using Text Area content
> - Bug 54107 - JSR223TestElement : Enable compilation and caching of Script Text
> - Bug 54109 - JSR223TestElement : SampleResult properties should be set before entering script to allow user setting different code
> - Bug 54230 - TCP Sampler, additions of "Close Connection", "SO_LINGER" and "End of line(EOL) byte value" options
> - Bug 54182 - Support sending of ByteMessage for JMS Publisher.

> ### Controllers

> - Bug 54131 - ForEach Controller : Add start and end index for looping over variables
> - Bug 54132 - Module Controller GUI : Improve rendering of referenced controller
> - Bug 54155 - ModuleController : Add a shortcut button to unfold the tree up to referenced controller and highlight it

> ### Listeners

> - Bug 54200 - Add support of several document types (like Apache OpenOffice's files, MS Office's files, PDF's files, etc.) to the elements View Results Tree, Assertion Response and Regular Expression Extractor (using Apache Tika)
> - Bug 54226 - View Results Tree : Show response even when server does not return ContentType header

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 54259 - Introduce a new Extractor that uses CSS or jquery-like selector syntax
> - Bug 45772 - RegEx User Parameters Post Processor
> - Bug 54160 - Add support for xpath assertion to apply to a JMeter variable.

> ### Functions

> - Bug 54189 - Add a function to quote ORO regexp meta characters
> - Bug 54418 - UUID Function

> ### I18N

> ### General

> - Bug 54005 - HTTP Mirror Server : Add special headers "X-" to control Response status and response content
> - Bug 53875 - Include suggested defaults for URL filters on HTTP Proxy
> - Bug 54031 - Add tooltip to running/total threads indicator
> - Webservice (SOAP) Request has been deprecated
> - Bug 54161 - Proxy : be able to create binary sampler for x-www-form-urlencoded POST request
> - Bug 54154 - HTTP Proxy Server should not force user to select the type of Sampler in HTTP Sampler Settings
> - Bug 54165 - Proxy Server: Improve rendering of target controller
> - Bug 46677 - Copying Test Elements between test plans
> - Bug 54204 - Result Status Action Handler : Add start next thread loop option
> - Bug 54232 - Search Feature : Add a button to search and expand results
> - Bug 54251 - Add tristate checkbox implementation
> - Bug 54257 - Enhance SamplerCreator interface to meet new requirements
> - Bug 54258 - Proxy : Use Raw Post Body when Sampler has one unnamed argument, useful for Samplers using POST method by of type JSON, XML, GWT body
> - Bug 54268 - Improve CPU and memory usage
> - Bug 54376 - ScopePanel : Allow configuring more precisely scopes
> - Bug 54412 - Changing JMeter defaults to ensure better performances by default
> - Bug 54414 - Remote Test should not start if one of the engines fails to start correctly

> ## Non-functional changes

> - Bug 53956 - Add ability to paste (a list of values) from clipboard for Header Manager
> - Updated to HttpComponents Client 4.2.3 (from 4.2.1)
> - Updated to HttpComponents Core 4.2.3 (from 4.2.2)
> - Bug 54110 - BSFTestElement and JSR223TestElement should use shared super-class for common fields
> - Bug 54199 - Move to Java 6
> - Upgraded to rhino 1.7R4

> # Version 2.8

> ## New and Noteworthy

> ### Core Improvements:

> #### Thread Group: New Option Delay thread creation until needed

> New Option "Delay thread creation until needed" that will create and start threads when needed instead of creating them on Test startup
> This new feature allows running tests with a huge number of short lived threads.

> #### HTTP Cookie Manager (IPv6 support)

> Add HTTPClient 4 cookie implementation in JMeter.
> Cookie Manager has now the default HC3.1 implementation and a new choice HC4 implementation (compliant with IPv6 address)

> #### Memory and performance improvements

> Significant improvements have been done in this version on memory usage of JMeterThread

> JSR223 Elements (enable using Groovy, scala... as scripting languages) have been improved to enable:

> - usage of Compilable interface when available to boost CPU usage
> - caching of Compilation when scripts are used as Files
> See JMeter Performances across versions

> #### OS Process Sampler

> Allow defining files for stdout/stderr/stdin.

> #### HTTP Request: PATCH verb

> Add PATCH verb to HTTP sampler

> #### HTTP Request: HTTPClient 4 is now the default implementation

> HTTPClient 4 is now the default HTTP Request implementation (and for Proxy element when generating HTTP requests).
> Previously the default was the HTTP Java implementation (i.e. the implementation provided by the JVM)

> #### HTTP Request

> Add Embedded URL Filter to HTTP Request Defaults Control (it was already present for HTTP Requests)

> #### Miscellanous

> - CSV Dataset : Embedded new lines are now supported in quoted data
> - JMX files now contain the version of JMeter that created the file
> - JMeter Version is now available as property "jmeter.version"

> ### Reporting Improvements:

> #### Response Time Graph

> Add a new visualizer Response Time Graph to draw a line graph showing the evolution of response time for a test

> Settings for Response Time Graph

> #### View Results in Table

> Add latency to View Result in Table listener

> #### Aggregate Graph

> Small improvements: legend at left or right is now on 1 column (instead of 1 large line), ...

> ### GUI and ergonomy Improvements:

> #### HTTP Proxy Server simplifications

> HTTPS Spoofing options have been removed from Proxy as HTTPS recording is directly available since JMeter 2.4.

> #### HTTP Proxy Server

> Allow URL Filters to be pasted from clipboard

> #### Find in JMeter

> CTRL + F for the new Find feature

> ESC key now closes popups.

> #### User Interface in GNOME 3

> Display 'Apache JMeter' title in app title bar in Gnome 3

> ## Known bugs

> The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).

> Changing language can break part of the configuration of the following elements (see Bug 53679 ):

> - CSV Data Set Config (sharing mode will be lost)
> - Constant Throughput Timer (Calculate throughput based on will be lost)

> Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>      [java] WARNING: Couldn't flush user prefs:
>      java.util.prefs.BackingStoreException:
>      java.lang.IllegalArgumentException: Not supported: indent-number

> This does not affect JMeter operation.

> ## Incompatible changes

> When using CacheManager, JMeter now caches responses for GET queries provided header Cache-Control is different from "no-cache" as described in specification. Furthermore it doesn't put anymore in Cache deprecated entries for "no-cache" responses. See Bug 53521 and Bug 53522

> A major change has occured on JSR223 Test Elements, previously variables set up before script execution where stored in ScriptEngineManager which was created once per execution, now ScriptEngineManager is a singleton shared by all JSR223 elements and only ScriptEngine is created once per execution, variables set up before script execution are now stored in Bindings created on each execution, see Bug 53365 .

> JSR223 Test Elements using Script file are now Compiled if ScriptEngine supports this feature, see Bug 53520 .

> Shortcut for Function Helper Dialog is now CTRL+F1 (CMD + F1 for Mac OS), CTRL+F (CMD+F1 for Mac OS) now opens Search Dialog.

> By default, the TestCompiler now stores details of which pairs it has seen in Controller instances rather than in a static Set. [ Bug 53796 ] This gives much better memory behaviour for delayed start test plans, as memory used is proportional to the number of concurrent threads. With the static Set memory usage was proportional to the total thread count. This change is very unlikely to cause a problem. The original behaviour can be restored by setting the property `TestCompiler.useStaticSet=true`

> HTTPS Spoofing options have been removed from Proxy as HTTPS recording is directly available since JMeter 2.4.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 53521 - Cache Manager should cache content with Cache-control=private
> - Bug 53522 - Cache Manager should not store at all response with header "no-cache" and store other types of Cache-Control having max-age value
> - Bug 53838 - Pressing "Stop" does not interrupt the TCP sampler
> - Bug 53911 - JmeterKeystore does not allow for key down the list of certificate

> ### Other Samplers

> - Bug 53348 - JMeter JMS Point-to-Point Request-Response sampler doesn't work when Request-queue and Receive-queue are different
> - Bug 53357 - JMS Point to Point reports too high response times in Request Response Mode
> - Bug 53440 - SSL connection leads to ArrayStoreException on JDK 6 with some KeyManagerFactory SPI
> - Bug 53511 - access log sampler SessionFilter throws NullPointerException - cookie manager not initialized properly
> - Bug 53715 - JMeter does not load WSDL

> ### Controllers

> ### Listeners

> - Bug 53742 - When jmeter.save.saveservice.sample_count is set to true, elapsed time read by listener is always equal to 0
> - Bug 53774 - RequestViewRaw does not show headers unless samplerData is non-null
> - Bug 53802 - IdleTime values are not saved to CSV log
> - Bug 53874 - View Results Tree : If some parameter containing special characters like % is not encoded, RequestViewHTTP fails with java.lang.IllegalArgumentException: URLDecoder: Illegal hex characters in escape (%) pattern and Response is not displayed

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 51512 - Cookies aren't inserted into HTTP request with IPv6 Host header

> ### Functions

> ### I18N

> ### General

> - Bug 53365 - JSR223TestElement should cache ScriptEngineManager
> - Bug 53520 - JSR223 Elements : Use Compilable interface to improve performances on File scripts
> - Bug 53501 - Synchronization timer blocks test end.
> - Bug 53750 - TestCompiler saves unnecessary entries in pairing collection
> - Bug 52266 - Code:Inconsistent synchronization
> - Bug 53841 - CSVSaveService reads file using JVM default file encoding instead of using the one configured in saveservice.properties
> - Bug 53953 New: Typo in monitor test plan documentation

> ## Improvements

> ### HTTP Samplers

> - Bug 53675 - Add PATCH verb to HTTP sampler
> - Bug 53931 - Define HTTPClient 4 for the default HTTP Request (and Proxy element to generate the HTTP requests). Before the default, it was the HTTP Java Sampler
> - Bug 53934 - Removes HTTPS spoofing options in JMeter HTTP Proxy Server. Since JMeter 2.4, the HTTPS protocol is directly supported by the proxy

> ### Other samplers

> - Bug 55310 - TestAction should implement Interruptible
> - Bug 53318 - Add Embedded URL Filter to HTTP Request Defaults Control
> - Bug 53782 - Enhance JavaSampler handling of JavaSamplerClient cleanup to use less memory
> - Bug 53168 - OS Process - allow specification of stdout/stderr/stdin
> - Bug 53844 - JDBC related elements should check class of Variable Name supposed to contain JDBC Connection Configuration to avoid ClassCastException

> ### Controllers

> - Bug 53671 - tearDown thread group to run even if shutdown test happens

> ### Listeners

> - Bug 53566 - Don't log partial responses to the jmeter log
> - Bug 53716 - Small improvements in aggregate graph: legend at left or right is now on 1 column (instead of 1 large line), no border to the reference's square color, reduce width on some fields
> - Bug 53718 - Add a new visualizer 'Response Time Graph' to draw a line graph showing the evolution of response time for a test
> - Bug 53738 - Keep track of number of threads started and finished
> - Bug 53753 - Summariser: no point displaying fractional time in most cases
> - Bug 53749 - TestListener interface could perhaps be split up. This should reduce per-thread memory requirements and processing, as only test elements that actually use testIterationStart functionality now need to be handled.
> - Bug 53941 - Add latency to View Result table listener

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 53755 - Adding a HttpClient 4 cookie implementation in JMeter. Cookie Manager has now the default HC3.1 implementation and a new choice HC4 implementation (compliant with IPv6 address)

> ### Functions

> - Bug 51527 - __time() function : add another option to __time() to provide *seconds* since epoch

> ### I18N

> ### General

> - Bug 53364 - Sort list of Functions in Function Helper Dialog
> - Bug 53418 - New Option "Delay thread creation until needed" that will create and start threads when needed instead of creating them on Test startup
> - Bug 42245 - Show clear passwords in HTTP Authorization Manager
> - Bug 53616 - Display 'Apache JMeter' title in app title bar in Gnome 3
> - Bug 53759 - ClientJMeterEngine perfoms unnecessary traverse using SearchByClass(TestListener)
> - Bug 52601 - CTRL + F for the new Find feature
> - Bug 53796 - TestCompiler uses static Set which can grow huge
> - Bug 53673 - Add JMeter version in the jmx file
> - Add support for HeapDump to the JMeter non-GUI and GUI client
> - Bug 53862 - Would be nice to have the JMeter Version available as a property
> - Bug 53806 - FileServer should provide thread-safe parsing
> - Bug 53807 - CSV Dataset does not handle embedded new lines in quoted data
> - Bug 53879 - GUI : Allow Popups to be closed with ESC key
> - Bug 53876 - Allow URL Filters (HTTP Proxy) to be pasted from clipboard

> ## Non-functional changes

> - Bug 53311 - JMeterUtils#runSafe should not throw Error when interrupted
> - Updated to commons-net-3.1 (from 3.0.1)
> - Updated to HttpComponents Core 4.2.2 (from 4.1.4) and HttpComponents Client 4.2.1 (from 4.1.3)
> - Bug 53765 - Switch to commons-lang3-3.1
> - Bug 53884 - wrong Maven groupId for commons-lang

> # Version 2.7

> ## New and Noteworthy

> ### OS Process Sampler

> A new System Sampler that can be used to execute commands on the local machine.

> OS Process Sampler results example with DNS lookup command 'dig'

> ### JMS Samplers improvements

> Addition of a "Non Persistent Delivery" option to send "Non-Persistent" (Guaranteed to be delivered at most once. Message loss is not a concern.) JMS messages

> Support sending of JMS Object Messages to enable sending Objects unmarshalled from XML by XStream

> Enable setting JMS Properties through JMS Publisher sampler

> ### Test Action sampler

> Allow premature exit from a loop

> ### Webservice Sampler improvements

> Add a jmeter property soap.document_cache to control size of Document Cache

> Make Maintain HTTP Session configurable

> ### Aggregate graph: Clustered Bar char with average, median, 90% line, min and max columns

> Aggregate graph changes to Clustered Bar chart, add more columns (median, 90% line, min, max) and options, fixed some bugs

> New settings for aggregate graph

> ### Improvements of HTML report design generated by JMeter Ant task in extras folder

> HTML report example

> HTML report example with some assertion errors

> ### Mailer Visualizer

> - Enable authentication, and connection security with SSL or TLS
> - Improve GUI design
> - Add internationalisation (i18n) support

> ### New Visual Indicator of number of ERROR/FATAL messages in logs

> Indicator shows number of ERROR/FATAL messsages in logs, it can be clicked to toggle Log Viewer panel

> ### Dialog box to show detail of a parameter row

> Add a detail button on parameters table to show detail of a Row

> Detail box example

> ### Plugin writers

> New interface org.apache.jmeter.engine.util.ConfigMergabilityIndicator has been introduced to tell whether a ConfigTestElement can be merged in Sampler (see Bug 53042 ):

>     public boolean applies(ConfigTestElement configElement);

> New interface org.apache.jmeter.protocol.http.proxy.SamplerCreator to allow plugging HTTP based samplers that differ from default HTTP Samplers through Proxy during Recording Phase (see Bug 52674 ):

>     public String[] getManagedContentTypes();

>     public HTTPSamplerBase createSampler(HttpRequestHdr request, Map<String, String> pageEncodings, Map<String, String> formEncodings);

>     public void populateSampler(HTTPSamplerBase sampler, HttpRequestHdr request, Map<String, String> pageEncodings, Map<String, String> formEncodings) throws Exception;

> ## Known bugs

> The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).

> ## Incompatible changes

> When doing replacement of User Defined Variables, Proxy will not substitute partial values anymore when "Regexp matching" is used. It will use Perl 5 word matching ("\b")

> In User Defined Variables, Test Plan, HTTP Sampler Arguments Table, Java Request Defaults, JMS Sampler and Publisher, LDAP Request Defaults and LDAP Extended Request Defaults, rows with empty Name and Value are no more saved.

> JMeter now expands the Test Plan tree to the testplan level and no further and selects the root of the tree. Furthermore default value of onload.expandtree is false.

> Graph Full Results Listener has been removed.

> When calling "Clear All" command, if Log Viewer is displayed its content will be cleared.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 52613 - Using Raw Post Body option, text gets encoded
> - Bug 52781 - Content-Disposition header garbled even if browser compatible headers is checked (HC4)
> - Bug 52796 - MonitorHandler fails to clear variables when starting a new parse
> - Bug 52871 - Multiple Certificates not working with HTTP Client 4
> - Bug 52885 - Proxy : Recording issues with HTTPS, cookies starting with secure are partly truncated
> - Bug 52886 - Proxy : Recording issues with HTTPS when spoofing is on, secure cookies are not always changed
> - Bug 52897 - HTTPSampler : Using PUT method with HTTPClient4 and empty Content Encoding and sending files leads to NullPointerException
> - Bug 53145 - HTTP Sampler - function in path evaluated too early

> ### Other Samplers

> - Bug 51737 - TCPSampler : Packet gets converted/corrupted
> - Bug 52868 - BSF language list should be sorted
> - Bug 52869 - JSR223 language list currently uses BSF list which is wrong
> - Bug 52932 - JDBC Sampler : Sampler is not marked in error in an Exception which is not of class IOException, SQLException, IOException occurs
> - Bug 52916 - JDBC Exception if there is an empty user defined variable
> - Bug 52937 - Webservice Sampler : Clear Soap Documents Cache at end of Test
> - Bug 53027 - Jmeter starts throwing exceptions while using SMTP Sample in a test plan with HTTP Cookie Mngr or HTTP Request Defaults
> - Bug 53072 - JDBC PREPARED SELECT statements should return results in variables like non prepared SELECT

> ### Controllers

> - Bug 52968 - Option Start Next Loop in Thread Group does not mark parent Transaction Sampler in error when an error occurs
> - Bug 50898 - IncludeController : NullPointerException loading script in non-GUI mode if Includers use same element name

> ### Listeners

> - Bug 43450 - Listeners/Savers assume SampleResult count is always 1; fixed Generate Summary Results

> ### Assertions

> - Bug 52848 - NullPointer in "XPath Assertion"

> ### Functions

> ### I18N

> - Bug 52551 - Function Helper Dialog does not switch language correctly
> - Bug 52552 - Help reference only works in English

> ### General

> - Bug 52639 - JSplitPane divider for log panel should be hidden if log is not activated
> - Bug 52672 - Change Controller action deletes all but one child samplers
> - Bug 52694 - Deadlock in GUI related to non AWT Threads updating GUI
> - Bug 52678 - Proxy : When doing replacement of UserDefinedVariables, partial values should not be substituted
> - Bug 52728 - CSV Data Set Config element cannot coexist with BSF Sampler in same Thread Plan
> - Bug 52762 - Problem with multiples certificates: first index not used until indexes are restarted
> - Bug 52741 - TestBeanGUI default values do not work at second time or later
> - Bug 52783 - oro.patterncache.size property never used due to early init
> - Bug 52789 - Proxy with Regexp Matching can fail with NullPointerException in Value Replacement if value is null
> - Bug 52645 - Recording with Proxy leads to OutOfMemory
> - Bug 52679 - User Parameters columns narrow
> - Bug 52843 - Sample headerSize and bodySize not being accumulated for subsamples
> - Bug 52967 - The function __P() couldn't use default value when running with remote server in GUI mode.
> - Bug 50799 - Having a non-HTTP sampler in a http test plan prevents multiple header managers from working
> - Bug 52997 - Jmeter should not exit without saving Test Plan if saving before exit fails
> - Bug 53136 - Catching Throwable needs to be carefully handled

> ## Improvements

> ### HTTP Samplers

> ### Other samplers

> - Bug 52775 - JMS Publisher : Add Non Persistent Delivery option
> - Bug 52810 - Enable setting JMS Properties through JMS Publisher sampler
> - Bug 52938 - Webservice Sampler : Add a jmeter property soap.document_cache to control size of Document Cache
> - Bug 52939 - Webservice Sampler : Make MaintainSession configurable
> - Bug 53073 - Allow to assign the OUT result of a JDBC CALLABLE to JMeter variables
> - Bug 53164 - New System Sampler
> - Bug 53172 - OS Process Sampler - allow specification of Environment Variables
> - Bug 52936 - JMS Publisher : Support sending of JMS Object Messages

> ### Controllers

> ### Listeners

> - Bug 52603 - MailerVisualizer : Enable SSL , TLS and Authentication
> - Bug 52698 - Remove Graph Full Results Listener
> - Bug 53070 - Change Aggregate graph to Clustered Bar chart, add more columns (median, 90% line, min, max) and options, fixed some bugs
> - Bug 53246 - Mailer Visualizer: improve GUI design and I18N

> ### Timers, Assertions, Config, Pre- & Post-Processors

> ### Functions

> ### I18N

> - Mailer Visualizer has been internationalized. French translation added. (see Bug 53246 )

> ### General

> - Bug 45839 - Test Action : Allow premature exit from a loop
> - Bug 52614 - MailerModel.sendMail has strange way to calculate debug setting
> - Bug 52782 - Add a detail button on parameters table to show detail of a Row
> - Bug 52674 - Proxy : Add a Sampler Creator to allow plugging HTTP based samplers using potentially non textual POST Body (AMF, Silverlight...) and customizing them for others
> - Bug 52934 - GUI : Open Test plan with the tree expanded to the testplan level and no further and select the root of the tree
> - Bug 52941 - Improvements of HTML report design generated by JMeter Ant task extra
> - Bug 53042 - Introduce a new method in Sampler interface to allow Sampler to decide wether a config element applies to Sampler
> - Bug 52771 - Documentation : Added RSS feed on JMeter Home page under link "Subscribe to What's New"
> - Bug 42784 - Show the number of errors logged in the GUI
> - Bug 53256 - Make Clear All command clean LogViewer content
> - Bug 53261 - Make "Error/fatal" counter added in Bug 42784 open Log Viewer panel when Warn Indicator is clicked

> ## Non-functional changes

> - Upgraded to rhino 1.7R3 (was js-1.7R2.jar). Note: the Maven coordinates for the jar were changed from rhino:js to org.mozilla:rhino. This does not affect JMeter directly, but might cause problems if using JMeter in a Maven project with other code that depends on an earlier version of the Rhino Javascript jar.
> - Bug 52675 - Refactor Proxy and HttpRequestHdr to allow Sampler Creation by Proxy
> - Bug 52680 - Mention version in which function was introduced
> - Bug 52788 - HttpRequestHdr : Optimize code to avoid useless work
> - JMeter Ant (ant-jmeter-1.1.1.jar) task was upgraded from 1.0.9 to 1.1.1
> - Updated to commons-io 2.2 (from 2.1)
> - Bug 53129 - Upgrade XStream from 1.3.1 to 1.4.2
> - Updated to httpcomponents-client 4.1.3 (from 4.1.2)
> - Updated JMeter distributed testing guide (jmeter_distributed_testing_step_by_step.pdf). Changes source format to OpenOffice odt (from sxw)

> # Version 2.6

> ## New and Noteworthy

> ### Toolbar

> A new toolbar on JMeter's main window

> ### JMeter start test button

> A new menu option and button allow to start a test ignoring the Pause Timers

> ### JMeter GUI Look and Feel

> Allow System or CrossPlatform LAF to be set from options menu

> ### JMeter GUI - duplicate node

> Add "duplicate node" in context menu

> ### JMeter tree view - search facility

> Functionality to search by keyword in Samplers Tree View

> ### HTTP Request - raw request pane

> Improve HTTP Request GUI to better show parameters without name (GWT RPC request or SOAP request for example)

> ### HTTP Request - other changes

> - Allow multiple selection in arguments panel
> - Allow to add (paste) entries from the clipboard to an arguments list
> - Ability to move variables up or down in HTTP Request

> ### HTTP Request - file protocol

> Better support for file: protocol in HTTP sampler

> Retrieve embedded resources with file: protocol

> ### HTTP Request - Ignore embedded resources failed

> Enable "ignore failed" for embedded resources

> Parent success with a embedded resource failed

> ### View Results in Table - child sample display

> Add option to TableVisualiser to display child samples instead of parent

> ### Key Store - multiple certificates

> Allowing multiple certificates (JKS)

> ### Aggregate graph improvements

> Some improvements on Aggregate Graph Listener:

> - new GUI for settings
> - dynamic graph size
> - allow to change fonts for title graph and legend
> - allow to change bar color (background and text values)
> - allow to draw or not bars outlines
> - allow to select only some samplers by a regexp filter
> - allow to define Y axis maximum scale

> Aggregate Graph bar

> ### Counter - new reset option

> Add an option to reset counter on each Thread Group iteration

> ### Functions

> - Add a new function __RandomString to generate random Strings
> - Add a new function __TestPlanName returning the name of the current "Test Plan"
> - Add a new function __machineIP returning IP address
> - Add a new function __jexl2 to support Jexl2

> ### User Defined Variable improvements

> - Add a comment field in User Defined Variables
> - Allow to add (paste) entries from the clipboard to an arguments list
> - Ability to move up or down variables in User Defined Variables

> ### View Results Tree

> In View Results Tree rather than showing just a message if the results are to big, show as much of the result as are configured

> ### Controllers - change elements

> Add ability to Change Controller elements

> ### JDBC pre- and post-processor

> Add JDBC pre- and post-processor

> ### JDBC transaction isolation option

> Allow to set the transaction isolation in the JDBC Connection Configuration

> ### Poisson Timer

> Add a Poisson based timer

> ### GUI and OS interaction

> Support for file Drag and Drop.

> ### Confirm Remove Dialog box

> Add a dialog box to confirm removing the element(s) when Remove action is called

> The dialogue can be skipped by setting the JMeter property `confirm.delete.skip=true`

> ### Remote batching support

> Use external store to hold samples during distributed testing, Added DiskStore remote sample sender: like Hold, but saves samples to disk until end of test

> ### JMS Subscriber sampler

> With JMS Subscriber, ability to use Selectors

> ### New Logger Panel

> A new Log Viewer has been added to the GUI and can be enabled from menu Options > Log Viewer:

> This Log Viewer shows the jmeter.log file, and useful (for example) to debug BeanShell/BSF scripts:

> ### The menu item Options / Choose Language is now fully functional

> The menu item Options / Choose Language now changes all the displayed text to the new language provided all messages are translated. You can help on this by translating into your language.

> ### Legacy JMX and JTL Avalon format support restored

> Support for reading/writing the original Avalon XML format of JMX (script) and JTL (sample result) files was dropped in JMeter version 2.4. JMeter can now read the Avalon format files again, however there is no support for saving files in the old format.

> ### JMeter jars available from Maven repository

> JMeter jars are now available from Maven repository.

> ## Known bugs

> The Include Controller has some problems in non-GUI mode (see Bugs 40671, 41286, 44973, 50898). In particular, it can cause a NullPointerException if there are two include controllers with the same name.

> The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).

> ## Incompatible changes

> JMeter versions since 2.1 failed to create a container sample when loading embedded resources. This has been corrected; can still revert to the Bug 51939 behaviour by setting the following property: `httpsampler.separate.container=false`

> Mirror server now uses default port 8081, was 8080 before 2.5.1.

> TCP Sampler handles SocketTimeoutException, SocketException and InterruptedIOException differently since 2.6, when these occurs, Sampler is marked as failed.

> Sample Sender implementations now resolve their configuration on Client side since 2.6. This behaviour can be changed with property sample_sender_client_configured (set it to false).

> The HTTP User Parameter Modifier test element has been removed; it has been deprecated for a long time.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 51932 - CacheManager does not handle cache-control header with any attributes after max-age
> - Bug 51918 - GZIP compressed traffic produces errors, when multiple connections allowed
> - Bug 51939 - Should generate new parent sample if necessary when retrieving embedded resources
> - Bug 51942 - Synchronisation issue on CacheManager when Concurrent Download is used
> - Bug 51957 - Concurrent get can hang if a task does not complete
> - Bug 51925 - Calling Stop on Test leaks executor threads when concurrent download of resources is on
> - Bug 51980 - HtmlParserHTMLParser double-counts images used in links
> - Bug 52064 - OutOfMemory Risk in CacheManager
> - Bug 51919 - Random ConcurrentModificationException or NoSuchElementException in CookieManager#removeMatchingCookies when using Concurrent Download
> - Bug 52126 - HttpClient4 does not clear cookies between iterations
> - Bug 52129 - Reported Body Size is wrong when using HTTP Client 4 and Keep Alive connection
> - Bug 52137 - Problems with HTTP Cache Manager
> - Bug 52221 - Nullpointer Exception with use Retrieve Embedded Resource without HTTP Cache Manager
> - Bug 52310 - variable in IPSource failed HTTP request if "Concurrent Pool Size" is enabled
> - Bug 52371 - API Incompatibility - Methods in HTTPSampler2 now require PostMethod instead of HttpMethod[Base]. Reverted to original types.
> - Bug 49950 - Proxy : IndexOutOfBoundsException when recording with Proxy server
> - Bug 52409 - HttpSamplerBase#errorResult modifies sampleResult passed as parameter; fix code which assumes that a new instance is created (i.e. when adding a sub-sample)
> - Bug 52507 - Delete Http User Parameters modifier (deprecated, obsolete)

> ### Other Samplers

> - Bug 51996 - JMS Initial Context leak newly created Context when Multiple Thread enter InitialContextFactory#lookupContext at the same time
> - Bug 51691 - Authorization does not work for JMS Publisher and JMS Subscriber
> - Bug 52036 - Durable Subscription fails with ActiveMQ due to missing clientId field
> - Bug 52044 - JMS Subscriber used with many threads leads to javax.naming.NamingException: Something already bound with ActiveMQ
> - Bug 52072 - LengthPrefixedBinaryTcpClientImpl may end a sample prematurely
> - Bug 52390 - AbstractJDBCTestElement:Memory leak and synchronization issue in perConnCache

> ### Controllers

> - Bug 51865 - Infinite loop inside thread group does not work properly if "Start next loop after a Sample error" option set
> - Bug 51868 - A lot of exceptions in jmeter.log while using option "Start next loop" for thread
> - Bug 51866 - Counter under loop doesn't work properly if "Start next loop on error" option set for thread group
> - Bug 52296 - TransactionController + Children ThrouputController or InterleaveController leads to ERROR sampleEnd called twice java.lang.Throwable: Invalid call sequence when TPC does not run sample
> - Bug 52330 - With next-Loop-On-Error after error samples are not executed in next loop

> ### Listeners

> - Bug 52357 - View results in Table does not allow for multiple result samples
> - Bug 52491 - Incorrect parsing of Post data parameters in Tree Listener / Http Request view

> ### Assertions

> - Bug 52519 - XMLSchemaAssertion uses JMeter JVM file.encoding instead of response encoding

> ### Functions

> - The CRLF example for the char function was wrong; CRLF=(0xD,0xA), not (0xC,0xA)

> ### I18N

> ### General

> - Bug 51937 - JMeter does not handle missing TestPlan entry well
> - Bug 51988 - CSV Data Set Configuration does not resolve default delimiter for header parsing when variables field is empty
> - Bug 52003 - View Results Tree "Scroll automatically" does not scroll properly in case nodes are expanded
> - Bug 27112 - User Parameters should use scrollbars
> - Bug 52029 - Command-line shutdown only gets sent to last engine that was started
> - Bug 52093 - Toolbar ToolTips don't switch language
> - Bug 51733 - SyncTimer is messed up if you a interrupt a test plan
> - Bug 52118 - New toolbar : shutdown and stop buttons not disabled when no test is running
> - Bug 52125 - StatCalculator.addAll(StatCalculator calc) joins incorrect if there are more samples with the same response time in one of the TreeMap
> - Bug 52339 - JMeter Statistical mode in distributed testing shows wrong response time
> - Bug 52215 - Confusing synchronization in StatVisualizer, SummaryReport ,Summariser and issue in StatGraphVisualizer
> - Bug 52216 - TableVisualizer : currentData field is badly synchronized
> - Bug 52217 - ViewResultsFullVisualizer : Synchronization issues on root and treeModel
> - Bug 43294 - XPath Extractor namespace problems
> - Bug 52224 - TestBeanHelper does not support NOT_UNDEFINED == Boolean.FALSE
> - Bug 52279 - Switching to another language loses icons in Tree and logs error Can't obtain GUI class from ...
> - Bug 52280 - The menu item Options / Choose Language does not change all the displayed text to the new language
> - Bug 52376 - StatCalculator#addValue(T val, int sampleCount) should use long, not int
> - Bug 49374 - Encoding of embedded element URLs depend on the file.encoding property
> - Bug 52399 - URLRewritingModifier uses default file.encoding to match text content
> - Bug 50438 - code calculates average with integer math, expecting double value
> - Bug 52469 - Changes in Support of SSH-Tunneling of RMI traffic for Remote Testing
> - Bug 52466 - Upgrade Test Plan feature : NameUpdater does not upgrade properties
> - Bug 52503 - Unify File->Close and Window close file saving behaviour
> - Bug 52537 - Help does not scroll to correct anchor when file is first loaded

> ## Improvements

> ### HTTP Samplers

> - Bug 51981 - Better support for file: protocol in HTTP sampler
> - Bug 52033 - Allowing multiple certificates (JKS)
> - Bug 52352 - Proxy : Support IPv6 URLs capture
> - Bug 44301 - Enable "ignore failed" for embedded resources

> ### Other samplers

> - Bug 51419 - JMS Subscriber: ability to use Selectors
> - Bug 52088 - JMS Sampler : Add a selector when REQUEST / RESPONSE is chosen
> - Bug 52104 - TCP Sampler handles badly errors
> - Bug 52087 - TCPClient interface does not allow for partial reads
> - Bug 52115 - SOAP/XML-RPC should not send a POST request when file to send is not found
> - Bug 40750 - TCPSampler : Behaviour when sockets are closed by remote host
> - Bug 52396 - TCP Sampler in "reuse connection mode" reuses previous sampler's connection even if it's configured with other host, port, user or password
> - Bug 52048 - BSFSampler, BSFPreProcessor and BSFPostProcessor should share the same GUI

> ### Controllers

> ### Listeners

> - Bug 52022 - In View Results Tree rather than showing just a message if the results are to big, show as much of the result as are configured
> - Bug 52201 - Add option to TableVisualiser to display child samples instead of parent
> - Bug 52214 - Save Responses to a file - improve naming algorithm
> - Bug 52340 - Allow remote sampling mode to be changed at run-time
> - Bug 52452 - Improvements on Aggregate Graph Listener (GUI and settings)
> - Resurrected OldSaveService to allow reading Avalon format JTL (result) files

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 52128 - Add JDBC pre- and post-processor
> - Bug 52183 - SyncTimer could be improved (performance+reliability)
> - Bug 52317 - Counter : Add option to reset counter on each Thread Group iteration
> - Bug 37073 - Add a Poisson based timer
> - Bug 52497 - Improve DebugSampler and DebugPostProcessor

> ### Functions

> - Bug 52006 - Create a function RandomString to generate random Strings
> - Bug 52016 - It would be useful to support Jexl2
> - __char() function now supports octal values
> - New function __machineIP returning IP address
> - Bug 51091 - New function returning the name of the current "Test Plan"

> ### I18N

> ### General

> - Bug 51892 - Default mirror port should be different from default proxy port
> - Bug 51817 - Moving variables up and down in User Defined Variables control
> - Bug 51876 - Functionality to search in Samplers TreeView
> - Bug 52019 - Add menu option to Start a test ignoring Pause Timers
> - Bug 52027 - Allow System or CrossPlatform LAF to be set from options menu
> - Bug 52037 - Remember user-set LaF over restarts.
> - Bug 51861 - Improve HTTP Request GUI to better show parameters without name (GWT RPC requests for example) (UNDER DEVELOPMENT)
> - Bug 52040 - Add a toolbar in JMeter main window
> - Bug 51816 - Comment Field in User Defined Variables control.
> - Bug 52052 - Using a delimiter to separate result-messages for JMS Subscriber
> - Bug 52103 - Add automatic scrolling option to table visualizer
> - Bug 52097 - Save As should point to same folder that was used to open a file if MRU list is used
> - Bug 52085 - Allow multiple selection in arguments panel
> - Bug 52099 - Allow to set the transaction isolation in the JDBC Connection Configuration
> - Bug 52116 - Allow to add (paste) entries from the clipboard to an arguments list
> - Bug 52160 - Don't display TestBeanGui items which are flagged as hidden
> - Bug 51886 - SampleSender configuration resolved partly on client and partly on server
> - Bug 52161 - Enable plugins to add own translation rules in addition to upgrade.properties. Loads any additional properties found in META-INF/resources/org.apache.jmeter.nameupdater.properties files
> - Bug 42538 - Add "duplicate node" in context menu
> - Bug 46921 - Add Ability to Change Controller elements
> - Bug 52240 - TestBeans should support Boolean, Integer and Long
> - Bug 52241 - GenericTestBeanCustomizer assumes that the default value is the empty string
> - Bug 52242 - FileEditor does not allow output to be saved in a File
> - Bug 51093 - when loading a selection previously stored by "Save Selection As", show the file name in the blue window bar
> - Bug 50086 - Password fields not Hidden in JMS Publisher, JMS Subscriber, Mail Reader sampler, SMTP sampler and Database Configuration
> - Bug 29352 - Use external store to hold samples during distributed testing, Added DiskStore remote sample sender: like Hold, but saves samples to disk until end of test.
> - Bug 52333 - Reduce overhead in calculating SampleResult#nanoTimeOffset
> - Bug 52346 - Shutdown detects if there are any non-daemon threads left which prevent JVM exit.
> - Bug 52281 - Support for file Drag and Drop
> - Bug 52471 - Improve Mirror Server performance by Using Pool of threads instead of launching a Thread for each request
> - Resurrected OldSaveService to allow reading Avalon format JMX files (removed in 2.4)
> - Add a dialog box to confirm removing the element(s) when Remove action is called
> - Bug 41788 - Log viewer (console window) needed as an option
> - Add option to change the pause time (default 2000ms) in the daemon thread which checks for successful JVM exit. The thread is not now started unless the pause time is greater than 0.

> ## Non-functional changes

> - fixes to build.xml: support scripts; localise re-usable property names
> - Bug 51923 - Counter function bug or documentation issue ? (fixed docs)
> - Update velocity.jar to 1.7 (from 1.6.2)
> - Update js.jar to 1.7R3 (from 1.6R5)
> - Update commons-codec 1.5 => 1.6
> - Update commons-io 2.0.1 => 2.1
> - Update commons-jexl 2.0.1 => 2.1.1
> - Update jdom 1.1 => 1.1.2
> - Update junit 4.9 => 4.10
> - Bug 51954 - Generated documents include entries which cause extra blank lines
> - Bug 52075 - JMeterProperty.clone() currently returns Object; it should return JMeterProperty
> - Updated httpcore to 4.1.4
> - Bug 49753 - Please publish jMeter artifacts on Maven central repository

> # Version 2.5.1

> ## Summary of main changes

> - HttpClient4 sampler now re-uses connections properly (previously it would use one per sample, which could quickly cause resource exhaustion).
> - Various fixes to JMS samplers
> - Functions are no longer spuriously invoked when used with a Configuration element
> - WebService sampler GUI has been re-organized for better design and more user-friendliness. Some improments on WSDL configuration assistant
> - Better handling of test shutdown. System.exit now only called if there is no other option; even this can be disabled.

> ## Known bugs

> The Include Controller has some problems in non-GUI mode. In particular, it can cause a NullPointerException if there are two include controllers with the same name.

> The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> The If Controller may cause an infinite loop if the condition is always false from the first iteration. A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).

> The menu item Options / Choose Language does not change all the displayed text to the new language. [The behaviour has improved, but language change is still not fully working] To override the default local language fully, set the JMeter property "language" before starting JMeter.

> ## Incompatible changes

> The HttpClient4 and Commons HttpClient 3.1 samplers previously used a retry count of 3. This has been changed to default to 1, to be compatible with the Java implementation. The retry count can be overridden by setting the relevant JMeter property, for example:

>     httpclient4.retrycount=3
>     httpclient3.retrycount=3

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Fix HttpClient 4 sampler so it reuses HttpClient instances and connections where possible.
> - Temporary fix to HC4 sampler to work round HTTPCLIENT-1120.
> - Bug 51863 - Lots of ESTABLISHED connections with HttpClient 4 implementation (vs HttpClient 3.1 impl)
> - Bug 51750 - Retrieve all embedded resources doesn't follow IFRAME
> - Bug 51752 - HTTP Cache is broken when using "Retrieve all embedded resources" with concurrent pool
> - Bug 39219 - HTTP Server: You can't stop it after File->Open
> - Bug 51775 - Port number duplicates in Host header when capturing by HttpClient (3.1 and 4.x)
> - Bug 50617 - Monitor Results legend show "dead" server although values from the server are retrieved

> ### Other Samplers

> - Bug 50424 - Web Methods drop down list box inconsistent
> - Bug 43293 - Java Request fields not cleared when creating new sampler
> - Bug 51830 - Webservice Soap Request triggers too many popups when Webservice WSDL URL is down
> - WebService(SOAP) request - add a connect timeout to get the wsdl used to populate Web Methods when server doesn't response
> - Bug 51841 - JMS : If an error occurs in ReceiveSubscriber constructor or Publisher, then Connections will stay open
> - Bug 51691 - Authorization does not work for JMS Publisher and JMS Subscriber
> - Bug 51840 - JMS : Cache of InitialContext has some issues
> - Bug 47888 - JUnit Sampler re-uses test object

> ### Controllers

> - If Controller - Fixed two regressions introduced by Bug 50032 (see Bug 50618 too)
> - If Controller - Catches a StackOverflowError when a condition returns always false (after at least one iteration with return true) See Bug 50618
> - Bug 51869 - NullPointer Exception when using Include Controller

> ### Listeners

> ### Assertions

> ### Functions

> - Bug 48943 - Functions are invoked additional times when used in combination with a Config Element

> ### I18N

> - WebService(SOAP) request - add I18N for some labels

> ### General

> - Bug 51831 - Cannot disable UDP server or change the maximum UDP port
> - Bug 51821 - Add short-cut for Enabling / Disabling (sub)tree or branches in test plan.
> - Bug 47921 - Variables not released for GC after JMeterThread exits.
> - Bug 51839 - "... end of run" printed prematurely
> - Bug 51847 - Some Junit tests are Locale sensitive and fail if Locale is different from US
> - Bug 51855 - Parent samples may have slightly inaccurate elapsed times
> - Bug 51880 - The shutdown command is not working if I invoke it before all the thread are started
> - Remote Shut host menu item was not being enabled.
> - Bug 51888 - Occasional deadlock when stopping a testplan

> ## Improvements

> ### HTTP Samplers

> - Bug 51380 - Control reuse of cached SSL Context from iteration to iteration
> - Bug 51882 - HTTPHC3Client uses a default retry count of 3, make it configurable; default is now 1
> - Change the default HttpClient 4 sampler retry count to 1

> ### Other samplers

> - Beanshell Sampler now supports Interruptible interface
> - Bug 51605 - WebService(SOAP) Request - WebMethod field value changes surreptitiously for all the requests when a value is selected in a request
> - WebService(SOAP) Request - Reorganized GUI for better design and more user-friendliness

> ### Controllers

> ### Listeners

> - Bug 42246 - Need for a 'auto-scroll' option in "View Results Tree" and "Assertion Results"
> - View Results Tree: Regexp Tester - little improvements on user interface

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 51885 - Allow a JMeter Variable as input to XPathExtractor

> ### Functions

> ### I18N

> ### General

> - Bug 51822 - (part 1) save 1 invocation of GuiPackage#getCurrentGui
> - Added AsynchSampleSender which sends samples from server to client asynchronously.
> - Upgraded to htmlparser 2.1; JavaMail 1.4.4; JUnit 4.9

> ## Non-functional changes

> - Bug 49976 - FormCharSetFinder visibility is default instead of public.
> - Bug 50917 - Property CookieManager.save.cookies not honored when set from test plan
> - Improve error logging when Javascript errors are detected.
> - Updated documentation footer

> # Version 2.5

> ## Summary of main changes

> - The HTTP implementation can now be selected at run-time, and JMeter now also supports Apache HttpComponents HttpClient 4.x. Note that Commons HttpClient 3.1 is no longer actively developed, and support may be removed from JMeter in a future release.
> - The HTTP sampler now allows concurrent downloads of embedded resources in an HTML page
> - The HTTP Sampler can now report the size of a request before decompression.
> - The JMS and Mail samplers have been improved.
> - The new Test Fragment Test Element makes using Include Controllers easier
> - There are various improvements to the View Results Tree Listener
> - Bug 30563 - Thread Group should have a start next loop option on Sample Error
> - There are two new Thread Group types - setUp and tearDown - which are run before and after the main Thread groups.
> - Client-Server mode now supports external stop/shutdown via UDP
>   multiple JMeter server instances can be started on the same host without needing to change the port property.
> - Bug 50516 - "Host" header in HTTP Header Manager is not included in generated HTTP request

> ## Known bugs

> The Include Controller has some problems in non-GUI mode. In particular, it can cause a NullPointerException if there are two include controllers with the same name.

> Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> The menu item Options / Choose Language does not change all the displayed text to the new language. [The behaviour has improved, but language change is still not fully working] To override the default local language fully, set the JMeter property "language" before starting JMeter.

> ## Incompatible changes

> Unsupported methods are no longer converted to GET by the Commons HttpClient sampler.

> Removed method public static long currentTimeInMs(). This has been replaced by the instance method public long currentTimeInMillis().

> ProxyControl.getSamplerTypeName() now returns a String rather than an int. This is internal to the workings of the JMeter Proxy & its GUI, so should not affect any user code.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 50178 - HeaderManager added as child of Thread Group can create concatenated HeaderManager names and OutOfMemoryException
> - Bug 50392 - value is trimmed when sending the request in Multipart
> - Bug 50686 - HeaderManager logging too verbose when merging instances
> - Bug 50963 - AjpSampler throws java.lang.StringIndexOutOfBoundsException
> - Bug 50516 - "Host" header in HTTP Header Manager is not included in generated HTTP request
> - Bug 50544 - In Apache Common Log the HEAD requests cause problems.
> - Bug 51268 - HTTPS request through an invalid proxy causes NullPointerException and does not show in result tree. Rather than delegating to the JMeter thread handler for "unexpected" failures, ensure all Exceptions generate a sample error.
> - Bug 51275 - Cookie Panel clearGui() sets incorrect default policy in Java 1.6

> ### Other Samplers

> - Bug 50173 - JDBCSampler discards ResultSet from a PreparedStatement
> - Ensure JSR223 Sampler has access to the current SampleResult
> - Bug 50977 - Unable to set TCP Sampler for individual samples

> ### Controllers

> - Bug 50032 - Last_Sample_Ok along with other controllers doesnt work correctly when the threadgroup has multiple loops
> - Bug 50080 - Transaction controller incorrectly creates samples including timer duration
> - Bug 50134 - TransactionController : Reports bad response time when it contains other TransactionControllers

> ### Listeners

> - Bug 50367 - Clear / Clear all in View results tree does not clear selected element

> ### Assertions

> - Bug 51488 - Assertion: Variable name scope is shared among all assertions (and Bug 51255 )

> ### Functions

> - Bug 50568 - Function __FileToString(): Could not read file when encoding option is blank/empty

> ### I18N

> - Bug 50811 - Incomplete Spanish translation

> ### General

> - Bug 49734 - Null pointer exception on stop Threads command (Run>Stop)
> - Bug 49666 - CSV Header read as data after EOF
> - Bug 45703 - Synchronizing Timer
> - Bug 50088 - fix getAvgPageBytes in SamplingStatCalculator so it returns what it should
> - Bug 50203 Cannot set property "jmeter.save.saveservice.default_delimiter=\t"
> - mirror-server.sh - fix classpath to use : separator (not ;)
> - Bug 50286 - URL Re-writing Modifier: extracted jsessionid value is incorrect when is between XML tags
> - System.nanoTime() tends to drift relative to System.currentTimeMillis(). Change SampleResult to recalculate offset each time. Also enable reversion to using System.currentTimeMillis() only.
> - Bug 50425 - Remove thread groups from Controller add menu
> - Bug 50675 - CVS Data Set Config incompatible with Remote Start Fixed RMI startup to provide location of JMX file relative to user.dir.
> - Bug 50221 - Renaming elements in the tree does not resize label
> - Bug 51002 - Stop Thread if CSV file is not available. JMeter now treats IOError as EOF.
> - Define sun.net.http.allowRestrictedHeaders=true by default. This fixes Bug 51238 .
> - Bug 51645 - CSVDataSet does not read UTF-8 files when file.encoding is UTF-8

> ## Improvements

> ### HTTP Samplers

> - AJP Sampler now implements Interruptible
> - Allow HTTP implementation to be selected at run-time
> - Bug 50684 - Optionally disable Content-Type and Transfer-Encoding in Multipart POST
> - Bug 50943 - Allowing concurrent downloads of embedded resources in html page
> - Bug 50170 - Bytes reported by http sampler is after GUnZip
>   Add optional properties to allow change the method to get response size
> - Hiding the proxy password on HTTP Sampler (just on GUI, not in JMX file)

> ### Other samplers

> - Bug 49622 - Allow sending messages without a subject (SMTP Sampler)
> - Bug 49603 - Allow accepting expired certificates on Mail Reader Sampler
> - Bug 49775 - Allow sending messages without a body
> - Bug 49862 - Improve SMTPSampler Request output.
> - Bug 50268 - Adds static and dynamic destinations to JMS Publisher
> - JMS Subscriber - Add dynamic destination
> - Bug 50666 - JMSSubscriber: support for durable subscriptions
> - Bug 50937 - TCP Sampler does not provide for / honor connect timeout
> - Bug 50569 - Jdbc Request Sampler to optionally store result set object data
> - Bug 51011 - Mail Reader: upon authentication failure, tell what you tried

> ### Controllers

> - Bug 50475 - Introduction of a Test Fragment Test Element for a better Include flow

> ### Listeners

> - View Results Tree - Add a dialog's text box on "Sampler result tab > Parsed" to display the long value with a double click on cell
> - Bug 37156 - Formatted view of Request in Results Tree
> - Bug 49365 - Allow result set to be written to file in a path relative to the loaded script
> - Bug 50579 - Error count is long, sample count is int. Changed sample count to long.
> - View Results Tree - Add new size fields: response headers and response body (in bytes) - derived from Bug 43363

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 48015 - Proposal new icons for pre-processor, post-processor and assertion elements
> - Bug 50962 - SizeAssertionGui validation prevents the use of variables for the size
> - Size Assertion - Add response size scope (full, headers, body, code, message) - derived from Bug 43363

> ### Functions

> - Bug 49975 - New function returning the name of the current sampler

> ### I18N

> - Add French translation for the new labels and reduce size for some labels (by abbreviation) on HTTP Sample

> ### General

> - Bug 30563 - Thread Group should have a start next loop option on Sample Error
> - Bug 50347 - Eclipse setup instructions should remind user to download dependent jars
> - Bug 50490 - Setup and Post Thread Group enhancements for better test flow.
> - All BeansShell test elements now have the script variables "prev" and "Label" defined.
> - Bug 50708 - Classpath jar order in NewDriver not alphabetically
> - Bug 50659 - JMeter server does not support concurrent tests - prevent client from starting another
> - Added remote shutdown functionality
> - Client JMeter engine now supports external stop/shutdown via UDP
> - UDP shutdown can now use a range of ports, from jmeterengine.nongui.port=4445 to jmeterengine.nongui.maxport=4455, allowing multiple JMeter instances on the same host without needing to change the port property.
> - Updated to httpcore 4.1.3 and httpclient 4.1.2

> ## Non-functional changes

> - Bug 50008 - Allow BatchSampleSender to be subclassed
> - Bug 50450 - use System.array copy in jacobi solver as, being native, is more performant.
> - Bug 50487 - runSerialTest verifies objects that never need persisting
> - Use Thread.setDefaultUncaughtExceptionHandler() instead of private ThreadGroup
> - Update to Commons Net 3.0

> # Version 2.4

> ## Summary of main changes

> - JMeter now requires at least Java 1.5.
> - HTTP Proxy can now record HTTPS sessions.
> - JUnit sampler now supports JUnit4 annotations.
> - Added JSR223 (javax.script) test elements.
> - MailReader Sampler can now use any protocol supported by the underlying implementation.
> - An SMTP Sampler has been added.
> - JMeter now allows users to provide their own Thread Group implementations.
> - View Results Tree now supports more display options, including search and Regex Testing.
> - StatCalculator performance is much improved; Aggregate Report etc. need far less memory.
> - JMS samplers have been extensively reworked, and should no longer lose messages. Correlation processing is improved. JMS Publisher and Subscriber now support both Topics and Queues.
> - Many other improvements have been made, please see below and in the manual.

> ## Known bugs

> The Include Controller has some problems in non-GUI mode. In particular, it can cause a NullPointerException if there are two include controllers with the same name.

> Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> The menu item Options / Choose Language does not change all the displayed text to the new language. [The behaviour has improved, but language change is still not fully working] To override the default local language fully, set the JMeter property "language" before starting JMeter.

> ## Incompatible changes

> HTTP Redirect now defaults to "Follow Redirects" rather than "Redirect Automatically". This is to enable JMeter to track cookies that may be sent during redirects. This does not affect existing test plans; it only affects the default for new HTTP Samplers.

> The Avalon file format for JMX and JTL files is no longer supported. Any such files will need to be converted by reading them in JMeter 2.3.4 and resaving them.

> The XPath Assertion and XPath Extractor elements no longer fetch external DTDs by default; this can be changed in the GUI.

> JMSConfigGui has been renamed as JMSSamplerGui. This does not affect existing test plans.

> The constructor public SampleResult(SampleResult res) has been changed to become a true "copy constructor". It no longer calls addSubResult(). This may possibly affect some 3rd party add-ons.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 47445 - Using Proxy with https-spoofing secure cookies need to be unsecured
> - Bug 47442 - Missing replacement of https by http for certain conditions using https-spoofing
> - Bug 48451 - Error in: SoapSampler.setPostHeaders(PostMethod post) in the else branch
> - Bug 48542 - SoapSampler uses wrong response header field to decide if response is gzip encoded
> - Bug 48568 - CookieManager broken for AjpSampler
> - Bug 48570 - AjpSampler doesn't support query parameters (GET/POST)
> - Bug 46901 - HTTP Sampler does not process var/func refs correctly in first file parameter
> - Bug 43678 - Handle META tag http-equiv charset?
> - Bug 49294 - Images not downloaded from redirected-to pages
> - Bug 49560 - wrong "size in bytes" when following redirections

> ### Other Samplers

> - Bug 47420 - LDAP extended request not closing connections during add request
> - Bug 48573 - LDAPExtSampler directory context handling
> - Bug 47870 - JMSSubscriber fails due to NPE
> - Bug 47899 - NullPointerExceptions in JMS ReceiveSubscriber constructor
> - Bug 48144 - NPE in JMS OnMessageSubscriber
> - Bug 47992 - JMS Point-to-Point Request - Response option doesn't work
> - Bug 48579 - Single Bind does not show config information when LdapExt Sampler is accessed
> - Bug 49111 - "Message With ID Not Found" Error on JMS P2P sampler.
> - Bug 47949 - JMS Subscriber never receives all the messages
> - Bug 46142 - JMS Point-to-Point correlation problems
> - Bug 48747 - TCP Sampler swallows exceptions
> - Bug 48709 - TCP Sampler Config setting "classname" has no effect

> ### Controllers

> - Bug 47385 - TransactionController should set AllThreads and GroupThreads
> - Bug 47940 - Module controller incorrectly creates the replacement Sub Tree
> - Bug 47592 - Run Thread groups consecutively with "Stop test" on error, JMeter will not mark to finished
> - Bug 48786 - Run Thread groups consecutively: with "Stop test now" on error or manual stop, JMeter leaves the green box active
> - Bug 48727 - Cannot stop test if all thread groups are disabled

> ### Listeners

> - Bug 48603 - Mailer Visualiser sends two emails for a single failed response
> - Correct calculation of min/max/std.dev for aggregated samples (Summary Report)
> - Bug 48889 - Wrong response time with mode=Statistical and num_sample_threshold > 1
> - Bug 47398 - SampleEvents are sent twice over RMI in distributed testing and non gui mode

> ### Assertions

> ### Functions

> ### I18N

> ### General

> - Bug 47646 - NullPointerException in the "Random Variable" element
> - Disallow adding any child elements to JDBC Configuration
> - BeanInfoSupport now caches getBeanDescriptor() - should avoid an NPE on non-Sun JVMs when using CSVDataSet (and some other TestBeans)
> - Bug 48350 - Deadlock on distributed testing with 2 clients
> - Bug 48901 - Endless wait by adding Synchronizing Timer
> - Bug 49149 - usermanual/index.html has typo in link to "Regular Expressions" page
> - Bug 49394 - Classcast Exception in ActionRouter.postActionPerformed
> - Bug 48136 - Essential files missing from source tarball.
>   Source archives now contain all source files, including source files previously only provided in the binary archives.
> - Bug 48331 - XpathExtractor does not return XML string representations for a Nodeset

> ## Improvements

> ### HTTP Samplers

> - Bug 47622 - enable recording of HTTPS sessions
> - Allow Proxy Server to be specified on HTTP Sampler GUI and HTTP Config GUI
> - Bug 47461 - Update Cache Manager to handle Expires HTTP header
> - Bug 48153 - Support for Cache-Control and Expires headers
> - Bug 47946 - Proxy should enable Grouping inside a Transaction Controller
> - Bug 48300 - Allow override of IP source address for HTTP HttpClient requests
> - Bug 49083 - collapse '/pathsegment/..' in redirect URLs

> ### Other samplers

> - JUnit sampler now supports JUnit4 tests (using annotations)
> - Bug 47900 - Allow JMS SubscriberSampler to be interrupted
> - Added JSR223 Sampler
> - Bug 47556 - JMS-PointToPoint-Sampler Timeout field should use Strings
> - Bug 47947 - Mail Reader Sampler should allow port to be overridden
> - Bug 48155 - Multiple problems / enhancements with JMS protocol classes
> - Allow MailReader sampler to use arbitrary protocols
> - Bug 45053 - SMTP-Sampler for JMeter
> - Bug 49552 - Add Message Headers on SMTPSampler
> - JMS Publisher and Subscriber now support both Topics and Queues. Added read Timeout to JMS Subscriber. General clean-up of JMS code.

> ### Controllers

> - Bug 47909 - TransactionController should sum the latency
> - Bug 41418 - Exclude timer duration from Transaction Controller runtime in report
> - Bug 48749 - Allowing custom Thread Groups
> - Bug 43389 - Allow Include files to be found relative to the current JMX file

> ### Listeners

> - Added DataStrippingSample sender - supports "Stripped" and "StrippedBatch" modes.
> - Added Comparison Assertion Visualizer
> - Bug 47907 - Improvements (enhancements and I18N) Comparison Assertion and Comparison Visualizer
> - Bug 36726 - add search function to Tree View Listener
> - Bug 47869 - Ability to cleanup fields of SampleResult
> - Bug 47952 - Added JSR223 Listener
> - Bug 47474 - View Results Tree support for plugin renderers
> - Allow Idle Time to be saved to sample log files
> - Bug 48259 - Improve StatCalculator performance by using TreeMap
> - Listeners using SamplingStatCalculator have much reduced memory needs as the Sample cache has been moved to the new CachingStatCalculator class. In particular, Aggregate Report can now handle large numbers of samples.
> - Aggregate Report and Summary Report now allow column headers to be optionally excluded
> - Bug 49506 - Add .csv File Extension in open dialog box from "read from file" functionality of listeners
> - Bug 49545 - Formatted (parsed) view of Sample Result in Results Tree

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 47338 - XPath Extractor forces retrieval of document DTD
> - Added Comparison Assertion
> - Bug 47952 - Added JSR223 PreProcessor and PostProcessor
> - Added JSR223 Assertion
> - Added BSF Timer and JSR223 Timer
> - Bug 48511 - add parent,child,all selection to regex extractor
> - Add Sampler scope selection to XPathExtractor
> - Regular Expression Extractor, Response Assertion and Size Assertion can now be applied to a JMeter variable
> - Bug 46790 - CSV Data Set Config should be able to parse CSV headers

> ### Functions

> - Bug 47565 - [Function] FileToString

> ### I18N

> - Bug 47938 - Adding some French translations for new elements
> - Bug 48714 - add new French messages

> ### General

> - Bug 47223 - Slow Aggregate Report Performance (StatCalculator)
> - Bug 47980 - hostname resolves to 127.0.0.1 - specifiying IP not possible
> - Bug 47943 - DisabledComponentRemover is not used in Start class
> - HeapDumper class for runtime generation of dumps
> - Basic read-only JavaMail provider implementation for reading raw mail files
> - Bug 49540 - Sort "Add" menus alphabetically

> ## Non-functional changes

> - Beanshell, JavaMail and JMS API (Apache Geronimo) jars are now included in the binary archive.
> - Add TestBean Table Editor support
> - Removed all external libraries from SVN; added download_jars Ant target
> - Updated various jar files:
>   - BeanShell - 2.0b4 => 2.0b5
>   - Commons Codec - 1.3 => 1.4
>   - Commons-Collections - 3.2 => 3.2.1
>   - JTidy => r938
>   - JUnit - 3.8.2 => 4.8.1
>   - Logkit - 1.2 => 2.0
>   - Xalan Serializer = 2.7.1 (previously erroneously shown as 2.9.1)
>   - Xerces xml-apis = 1.3.04 (previously erroneously shown as 2.9.1)
>   - Some jar files were renamed.

> # Version 2.3.4

> ## Summary of main changes

> This is a minor bug-fix release, mainly to correct some bugs that were accidentally added in 2.3.3.

> ## Known bugs

> The Include Controller has some problems in non-GUI mode. In particular, it can cause a NullPointerException if there are two include controllers with the same name.

> Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> The menu item Options / Choose Language does not change all the displayed text to the new language. [The behaviour has improved, but language change is still not fully working] To override the default local language fully, set the JMeter property "language" before starting JMeter.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 47321 - HTTPSampler2 response timeout not honored

> ### Other Samplers

> - Bug 47290 - Infinite loop on connection factory lookup (JMS)
> - JDBC Sampler should not close Prepared or Callable statements as these are cached

> ### Controllers

> - Bug 39509 - Once-only controller running twice

> ### Listeners

> - Change ResultCollector to only warn if the directory was not created
> - Fix some synchronisation issues in ResultCollector and SampleResult (wrong locks were being used)

> ### I18N

> - Fixed bug introduced in 2.3.3: JMeter does not start up if there is no messages.properties file for the default Locale.

> ### General

> - Fix problems with remote clients - bug introduced in 2.3.3
> - Bug 47377 - Make ClassFinder more robust and close zipfile resources
> - Fix some errors in generating the documentation (latent bug revealed in 2.3.3 when Velocity was upgraded)

> ## Improvements

> ### Other samplers

> - Bug 47266 - FTP Request Sampler: allow specifying an FTP port, other than the default

> # Version 2.3.3

> ## Summary of main changes

> The handling of test closedown is much improved. The gradual "Shutdown" command now waits until all threads have stopped, and does not report an error if threads don't stop within 5 seconds. The immediate "Stop" command can now be used if "Shutdown" takes too long. Also the immediate "Stop" command is able to interrupt samplers which support the new Interruptible interface (e.g. HTTP and SOAP, FTP). This allows immediate completion of pending responses. Non-GUI mode tests can also now be sent a "Shutdown" or "Stop" message. Test Action now supports a "Stop Now" action, as do the Thread Group and Result Status Action Handler Post Processor elements.

> HTTP Cookie handling is improved, and HTTP POST can now use variable file names correctly. HTTP, SOAP/XML-RPC and WebService(SOAP) sampler character encodings updated to be more consistent. HTTP Samplers now support connection and response timeouts (requires JVM 1.5 for the HTTP Java sampler). Together with the closedown improvements described above, this should avoid most cases where a test run hangs. Multiple Header Manager elements are now supported for a single HTTP sampler. The Proxy Server is improved, and no longer stores "Host" headers by default.

> JDBC Request can optionally save the results of Select statements to variables. JDBC Request now handles quoted strings and UTF-8, and can handle arbitrary variable types.

> There are several new functions : __char() function: allows arbitrary Unicode characters to be entered in fields. __unescape() function: allows Java-escaped strings to be used. _unescapeHtml() function: decodes Html-encoded text. __escapeHtml() function: encodes text using Html-encoding. A reference to a missing function - e.g. ${__missing(a)} - is now treated the same as a missing variable. Previously the function name - and leading { - were dropped. This makes it easier to debug test plans.

> Some Assertions can now be applied to sub-samples as well as (or instead of) just the parent sample. There is a new Random Variable Configuration element.

> JMS samplers are much improved (see details below). The TCP Sampler now supports some additional clients and is a bit more flexible.

> Client-server mode has been improved, and the server can optionally use a fixed RMI port, which should help with setting up firewalls.

> Various I18N changes have been made; language change works better (though not perfect yet). There are improved French translations as well as new Polish and Brazilian Portugese translations.

> The BeanShell jar is now included with the binary archive; there is no need to download it separately.

> ## Known bugs

> The Include Controller has some problems in non-GUI mode. In particular, it can cause a NullPointerException if there are two include controllers with the same name.

> Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> The menu item Options / Choose Language does not change all the displayed text to the new language. [The behaviour has improved, but language change is still not fully working] To override the default local language fully, set the JMeter property "language" before starting JMeter.

> ## Incompatible changes

> When loading sample results from a file, previous results are no longer cleared. This allows one to merge multiple files. If the previous behaviour is required, use the menu item Run/Clear (Ctrl+Shift+E) or Run/Clear All (Ctrl+E) before loading the file.

> The test elements "Save Results to a file" and "Generate Summary Results" are now shown as Listeners. They were previously shown as Post-Processors, even though they are implemented as Listeners.

> The Cookie Manager no longer saves incoming cookies as variables by default. To save cookies as variables, define the property "CookieManager.save.cookies=true". Also, cookies names are prefixed with "COOKIE_" before they are stored (this avoids accidental corruption of local variables) To revert to the original behaviour, define the property "CookieManager.name.prefix= " (one or more spaces).

> The Counter element is now shown as a Configuration element. It was previously shown as a Pre-Processor, even though it is implemented as a Config item.

> The above changes only affect the icons that are displayed and the locations in the GUI pop-up menus. They do not affect test plans or test behaviour.

> The PreProcessors are now invoked directly by the JMeterThread class, rather than by the TestCompiler#configureSampler() method. (JMeterThread handles the PostProcessors). This does not affect test plans or behaviour, but could perhaps affect 3rd party add-ons (very unlikely).

> Moved the Scoping Rules sub-section from Section 3. "Building a Test Plan" to Section 4. "Elements of a test plan"

> The While controller now trims leading and trailing spaces from the condition value before it is compared with LAST, blank or false.

> The "threadName" variable in the _jexl() and __javaScript() functions was previously misspelt as "theadName".

> The following deprecated methods were removed from JOrphanUtils: booleanToString(boolean) and valueOf(boolean). Java 1.4+ has these methods in the Boolean class.

> The TestElement interface has some new methods:

> - void setProperty(String key, String value, String dflt)
> - void setProperty(String key, boolean value, boolean dflt)
> - void setProperty(String key, int value)
> - void setProperty(String key, int value, int dflt)
> - int getPropertyAsInt(String key, int defaultValue)
> These are implemented in the AbstractTestElement class which all elements should extend so this is unlikely to cause a problem.

> ## Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 46332 - HTTP Cookie Manager ignores manually defined cookies (bug introduced in r707810)
> - Cookie Manager was not passing cookie policy to runtime threads so they always used compatibility mode
> - Add version attribute to JMeter Cookie class (needed for proper cookie support)
> - Cookie Manager now saves/restores cookie versions
> - Check validity of cookies before storing them.
> - HTTPSamplers can now use variables in POSTed file names
> - Fix processing of first file name in HTTP POST so functions/variables work (bug introduced with multiple file support)
> - Bug 45831 - WS Sampler reports incorrect throughput if SOAP packet creation fails
> - HTTP, SOAP/XML-RPC and WebService(SOAP) sampler character encodings updated to be more consistent
> - Bug 46148 - HTTP sampler fails on SSL requests when logging for jmeter.util is set to DEBUG
> - Fix Java 1.6 https error: java.net.SocketException: Unconnected sockets not implemented
> - Bug 46838 - if there was no data, still need to set latency in HTTPSampler
> - Bug 46993 - Saving from Header Manager generates ClassCastException
> - Bug 46690 - handling of 302 redirects with invalid relative paths. JMeter now removes extraneous leading "../" segments (as do many browsers)
> - Bug 44521 - empty variables for a POST in the HTTP Request don't get ignored
> - Bug 46977 - JMeter does not handle HTTP headers not delimited by whitespace
> - Fix bug in HTTP file: handling - read bytes, not characters in the default encoding.
> - Remove Host from headers saved by the Proxy server, as that will normally be generated by the HTTP stack
> - Bug 45199 - don't try to replace blank variables in Proxy recording
> - Change HTTPS spoofing so https: links are replaced even when URL match fails
> - Bug 46436 - Improve error reporting in Proxy Gui
> - Bug 46435 - More verbose error msg for error 501 (Proxy Server)

> ### Other Samplers

> - The "prev" and "sampler" objects are now defined for BSF test elements
> - Fix NPE (in DataSourceElement) when using JDBC in client-server mode
> - Bug 45425 - JDBC Request does not support Unicode (changed sampler to use UTF-8)
> - Bug 46522 - Incorrect "Response data" in JDBC sample when column names are missing
> - Bug 46821 - JDBC select request doesn't store the first column in the variables
> - Bug 43791 - ensure QueueReceiver is closed in JMS Point to Point sampler
> - Bug 46016 - avoid possible NPE in JMSSampler
> - Bug 46142 - JMS Receiver now uses MessageID
> - Bug 45458 - Point to Point JMS in combination with authentication
> - Bug 45460 - JMS TestPlan elements depend on resource property
> - Various ReceiveSubscriber thread-safety fixes
> - JMSPublisher and Subscriber fixes: thread-safety, support dynamic locale changes, locale independence for JMX attribute values
> - FTP Sampler now logs out before disconnecting.
> - TCP sampler now calls setupTest() and teardownTest() methods
> - Bug 45887 - TCPSampler: timeout property incorrectly set

> ### Controllers

> - Fix NPE when using nested Transaction Controllers with parent samples
> - Fix processing of Transaction Controller parent mode so current sampler is set to actual sampler
> - Bug 44941 - Throughput controllers should not share global counters
> - Bug 47120 - Throughput Controller: change percent executions to total executions, the value is stored in a String and interpreted as 1 execution
> - Bug 47150 - ThreadGroup with a loop count of zero causes infinite loop
> - Bug 47009 - Insert parent caused child controller name to be reset
> - Bug 47165 - Using duplicate Module Controller names in command line mode causes NPE

> ### Listeners

> - Mailer Visualizer documentation now agrees with code i.e. failure/success counts need to be exceeded to trigger the mail.
> - Mailer Visualizer now shows the failure count
> - Mailer Visualiser - fix parsing of multiple e-mail address when using Test button
> - Bug 45976 - incomplete result file when using remote testing with more than 1 server
> - Fix Summariser so it works in client server mode
> - Bug 34096 - Duplicate samples not eliminated when writing to CSV files
> - Save "Include group Name in Label" setting in Aggregate and Summary reports
> - The JMeter variable "sample_variables" is sent to all server instances to ensure the data is available to the client.
> - CSVSaveService - check for EOF while reading quoted string

> ### Assertions

> - Bug 45749 - Response Assertion does not work with a substring that happens to be an invalid RE
> - Bug 45904 - Allow 'Not' Response Assertion to succeed with null sample

> ### Functions

> - Fix regex function - was failing to process $m$mid$n$ correctly
> - Protect against possible NPE in RegexFunction if called during test shutdown.
> - Avoid NPE if XPath function does not match any nodes
> - Correct the variable name "theadName" to "threadName" in the __jexl() and __javaScript() functions
> - A reference to a missing function - e.g. ${__missing(a)} - is now treated the same as a missing variable. Previously the function name - and leading { - were dropped.

> ### I18N

> - Fixed language change handling for menus (does not yet work for TestBeans)
> - Add HeaderAsPropertyRenderer to support header resource names; use this to fix locale changes in various GUI elements
> - Bug 46424 - corrections to French translation
> - Bug 46844 - "Library" label in test plan are not I18N
> - Bug 47064 - fixes for Mac LAF
> - Bug 47127 - Unable to change language to pl_PL
> - Bug 47137 - Labels in View Results Tree aren't I18N
> - Bug 46423 - I18N of Proxy Recorder
> - Bug 45928 - AJP/1.3 Sampler doesn't retrieve its label from messages.properties

> ### General

> - Prompt to overwrite an existing file when first saving a new test plan
> - Amend TestBeans to show the correct popup menu for Listeners
> - Bug 45185 - CSV dataset blank delimiter causes OOM
> - Fix incorrect GUI classifications: "Save Results to a file" and "Generate Summary Results" are now shown as Listeners. "Counter" is now shown as a Configuration element.
> - Bug 41608 - misleading warning log message removed
> - Bug 46359 - BSF JavaScript Preprocessor cannot access sampler variable on first interation (Implement temporary work-round for BSF-22)
> - Bug 46407 - BSF elements do not load script files, attempt to interpret filename as script
> - Better handling of Exceptions during test shutdown
> - Fix potential thread safety issue in JMeterThread class
> - Bug 46491 - Incorrect value for the last variable in "CSV Data Set Config" (error in processing quoted strings)

> ## Improvements

> ### HTTP Samplers

> - Bug 45479 - Support for multiple HTTP Header Manager nodes
> - HTTP Samplers now support connection and request timeouts (requires Java 1.5 for Java Http sampler)
> - Apache SOAP 2.3.1 does not give access to HTTP response code/message, so WebService sampler now treats an empty response as an error
> - Mirror server now supports "X-Sleep" header - if this is set, the responding thread will wait for the specified number of milliseconds
> - Bug 45694 - Support GZIP compressed logs in Access Log Sampler

> ### Other samplers

> - JDBC Request can optionally save the results of Select statements to variables.
> - JDBC Request now handles quoted strings.
> - JDBC Request now handles arbitrary variable types.
> - LDAP result data now formatted with line breaks
> - Bug 45200 - MailReaderSampler: store the whole MIME message in the SamplerResult
> - Bug 45571 - JMS Sampler correlation enhancement
> - Bug 46030 - Extend TCP Sampler to Support Length-Prefixed Binary Data
> - Add classname field to TCP Sampler GUIs

> ### Controllers

> - Allow If Controller to use variable expressions (not just Javascript)
> - Trim spaces from While Controller condition before comparing against LAST, blank or false

> ### Listeners

> - Save Responses to a file can save the generated filename(s) to variables.
> - Add option to skip suffix generation in Save Responses to a File
> - Bug 43119 - Save Responses to file: optionally omit the file number
> - Add BSF Listener element
> - Bug 47176 - Monitor Results : improve load status graphic
> - Bug 40045 - Allow Results monitor to select a specific connector
> - Read XML JTL files more efficiently - pass samples to visualisers as they are read, rather than saving them all and then processing them

> ### Assertions, Config, Pre- & Post-Processors

> - Bug 45903 - allow Assertions to apply to sub-samples
> - Add Body (unescaped) source option to Regular Expression Extractor.
> - Random Variable - new configuration element to create random numeric variables

> ### Functions

> - Add OUT and log variables to __jexl() function
> - Use Script to evaluate __jexl() function so can have multiple statements.
> - Add log variable to the __javaScript() function
> - Added __char() function: allows arbitrary Unicode characters to be entered in fields.
> - Added __unescape() function: allows Java-escaped strings to be used.
> - Added __unescapeHtml() function: decodes Html-encoded text.
> - Added __escapeHtml() function: encodes text using Html-encoding.

> ### I18N

> - Bug 45929 - improved French translations
> - Bug 47132 - Brazilian Portuguese translations
> - Bug 46900 - Polish translations
> - Added locales.add property to allow for new Locales

> ### General

> - Allow spaces in JMeter path names (apply work-round for Java Bug 4496398 )
> - Process JVM_ARGS last in script files so users can override default settings
> - Bug 46636 - Allow server mode to optionally use a fixed rmi port
> - Make some samplers interruptible: HTTP (both), SoapSampler, FTPSampler
> - Test Action now supports "Stop Now" action, as do the Thread Group and Result Status Post Processor elements
> - The Menu items Stop and Shutdown now behave better. Shutdown will now wait until all threads exit. In GUI mode it can be cancelled and Stop run instead. Stop now reports if some threads will not exit, and exits if running in non-GUI mode
> - Add UDP server to wait for shutdown message if running in non-GUI mode; add UDP client to send the message.
> - Bug 41209 - JLabeled* and ToolTips
> - Include BeanShell 2.0b4 jar in binary download.

> ## Non-functional changes

> - Introduce AbstractListenerGui class to make it easier to create Listeners with no visual output
> - Assertions are run after PostProcessors; change order of pop-up menus accordingly
> - Remove unnecessary clone() methods from function classes
> - Moved PreProcessor invocation to JMeterThread class
> - Made HashTree Map field final
> - Improve performance of calling ResultCollector#isSampleWanted() for multiple samples
> - Updated to new versions of: xmlgraphics-commons (1.3.1), jdom (1.1), xstream (1.3.1), velocity (1.6.2)

> ## Version 2.3.2

> ### Summary of main changes

> #### Bug fixes

> Version 2.3.1 changed the way binary and text content types were determined as far as the View Results Tree Listener was concerned: originally everything except "image/" content types were considered text, but 2.3.1 introduced a check for specific content types. This has caused problems, as several popular types were omitted and these were no longer shown by default in the Response tab. Rather than try to list all the possible text types, JMeter now just checks for the following binary types:

> - image/*
> - audio/*
> - video/*
> All other types are now assumed to be text.

> JMeter 2.3.1 introduced a bug in the Cookie Manager - if "Clear Cookie each iteration" was selected, all threads would see the same cookies. This bug has been corrected.

> #### Improvements

> The Proxy server can now record binary requests. By default the content types application/x-amf and application/x-java-serialized-object will be treated as binary and saved in a file. To change the content types, update the property proxy.binary.types .

> The CSV Dataset configuration element has new file sharing options: per thread group, per thread, per identifier. This allows for more flexible file processing, e.g. each thread can process the same data in the same order.

> Switch Controller now works properly with functions and variables, and the condition can now be a name instead of a number. Simple Controller now works properly under a While Controller

> CSV fields in JTL files can now contain delimiters. CSV and XML files can now contain additional variables (define the JMeter property sample_variables ).

> Response Assertion can now match on substrings (i.e. not regular expression). Regex extractor can operate on variables.

> XPath processing is improved; Tidy errors are handled better.

> Save Table Data buttons added to Summary and Aggregate reports to allow easy saving of the calculated data.

> HTTP samplers can now save just the MD5 hash of responses, rather than the entire response. As a special case, if the HTTP Sampler path starts with "http://" or "https://" then this is used as the full URL, overriding the host and port fields. The HTTP Samplers can now POST multiple files. Webservice(SOAP) Sampler can now load local WSDL files using the "file:" protocol.

> A simple HTTP Cache Manager has been added. This needs further development.

> View Results Tree Listener now uses Tidy to display XML. This should allow more content to be displayed succesfully. It also avoids the need to download remote DTD files, which can slow the rendering considerably.

> MailReader sampler now supports POP3S and IMAPS protocols. Individual mails are now added as sub-samples.

> Various improvements to the BSF Sampler: now supports Jexl, and Javascript bug works properly. Added BSF PreProcessor, PostProcessor and Assertion test elements. All now have access to "props" JMeter Properties object.

> Number of classes loaded in non-GUI mode is much reduced.

> ### Known bugs

> The Include Controller has some problems in non-GUI mode. In particular, it can cause a NullPointerException if there are two include controllers with the same name.

> Once Only controller behaves OK under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> The menu item Options / Choose Language does not change all the displayed text to the new language. To override the default local language, set the JMeter property "language" before starting JMeter.

> ### Incompatible changes

> - To reduce the number of classes loaded in non-GUI mode, Functions will only be found if their classname contains the string '.functions.' and does not contain the string '.gui.'. All existing JMeter functions conform to this restriction. To revert to earlier behaviour, comment or change the properties classfinder.functions.* in jmeter.properties.
> - The reference value parameter for intSum() is now optional. As a consequence, if a variable name is used, it must not be a valid integer.
> - The supplied TCPClient implementation no longer treats tcp.eolByte=0 as special. To skip EOL checking, set tcp.eolByte=1000 (or some other value which is not a valid byte)
> - Leading and trailing spaces are trimmed from variable names in function calls. For example, ${__Random(1,63, LOTTERY )} will use the variable 'LOTTERY' rather than ' LOTTERY '.
> - Synchronization has been removed from the RunningSample class (it was not fully threadsafe anyway). Developers of 3rd party add-ons that use the class may need to synchronize access.

> ### Bug fixes

> - Check that the CSV delimiter is reasonable.
> - Fix Switch Controller to work properly with functions and variables
> - Bug 44011 - application/soap+xml not treated as a text type
> - Bug 43427 - Simple Controller is only partly executed in While loop
> - Bug 33954 - Stack Overflow in If/While controllers (may have been fixed previously)
> - Bug 44022 - Memory Leak when closing test plan
> - Bug 44042 - Regression in Cookie Manager (Bug introduced in 2.3.1)
> - Bug 41028 - JMeter server doesn't alert the user when the host is defined as a loopback address
> - Bug 44142 - Function __machineName causes NPE if parameters are omitted.
> - Bug 44144 - JMS point-to-point: request response test does not work
> - Bug 44314 - Not possible to add more than one SyncTimer
> - Capture Tidy console error output and log it
> - Fix problems using Tidy(tolerant parser) in XPath Assertion and XPath Extractor
> - Bug 44374 - improve timer calculation
> - Regular Expression Extractor now deletes all stale variables from previous matches.
> - Bug 44707 - Running remote test changes internal test plan
> - Bug 44625 - Cannot have two or more FTP samplers with different "put" and "get" actions
> - Bug 40850 - BeanShell memory leak
> - Ensure ResponseCode and ResponseMessage are set for successful JDBC samples
> - FTPSampler now detects and reports failure to open the remote file
> - Class directories defined in search_paths and user.classpath no longer need trailing "/"
> - Bug 44852 SOAP/ XML-RPC Request does not show Request details in View Results Tree
> - WebService(SOAP) Sampler ResponseData now includes the EOLs sent by server
> - Bug 44910 - close previous socket (if any) in TCP Sampler
> - Bug 44912 - Filter not working in Log Parser
> - The BeanShell and BSF component documentation made some incorrect references to the "SampleResponse" object; this has been corrected to "SampleResult"
> - BSF Sampler now works properly with Javascript
> - Test Action "Stop Test" now works
> - Bug 42833 - Argument class uses LinkedHashMap in getArgumentsAsMap() to preserve ordering
> - Bug 45093 - SizeAssertion did not call getBytes()
> - Bug 45007 - Rewrite Location headers when using Proxy HTTPS spoofing
> - Use CRLF rather than LF in Proxy when returning headers to the client
> - Bug 45007 - fix content length header if content may have been changed

> ### Improvements

> - CSV files can now handle fields with embedded delimiters.
> - longSum() function added
> - Bug 43382 - configure Tidy output (warnings, errors) for XPath Assertion and Post-Processor
> - Bug 43984 - trim spaces from port field
> - Add optional comment to __log() function
> - Make Random function variable name optional
> - Reduce class loading in non-GUI mode by only looking for Functions in class names that contain '.functions.' and don't contain '.gui.'
> - Bug 43379 - Switch Controller now supports selection by name as well as number
> - Can specify list of variable names to be written to JTL files (CSV and XML format)
> - Now checks that the remoteStart options -r and -R are only used with non_GUI -n option
> - Bug 44184 - Allow header to be saved with Aggregate Graph data
> - Added "Save Table Data" buttons to Aggregate and Summary Reports - save table as CSV format with header
> - Allow most functions to be used on the Test Plan. Note __evalVar(), __split() and __regex() cannot be used on the Test Plan.
> - Allow Global properties to be loaded from a file, e.g. -Gglobal.properties
> - Add "Substring" option to Response Assertion
> - Bug 44378 - Turkish localisation
> - Add optional output variable name to Jexl function
> - Add application/vnd.wap.xhtml+xml as a text type
> - Add means to override maximum display size in View Results Tree - set the property: view.results.tree.max_size
> - Use Tidy to display XML in View Results Tree Listener (avoids fetching DTDs)
> - Bug 44487 - German translation
> - As a special case, if the HTTP Sampler path starts with "http://" or "https://" then this is used as the full URL.
> - Bug 44575 - Result Saver can now save only successful results
> - Bug 44650 - CSV Dataset now handles quoted column values
> - Bug 44600 - 1-ms resolution timer when running with Java 1.5+
> - Bug 44632 - Text input enhancement to FTP Sampler
> - Bug 42204 - add thread group name to Aggregate and Summary reports
> - FTP Sampler sets latency = time to login
> - FTP Sampler sets a URL if it can
> - Bug 41921 - add option for samplers to store MD5 of response; done for HTTP Samplers.
> - Regex Function can now also be applied to a variable rather than just the previous sample result.
> - Remove HTML Parameter Mask,HTTP User Parameter Modifier from menus as they are deprecated
> - Bug 44807 - allow session ids to be terminated by backslash
> - Bug 44784 - allow for broken server returning additional charset
> - Added TESTSTART.MS property / variable = test start time in milliseconds
> - Add POP3S and IMAPS protocols to Mail Reader Sampler.
> - Mail Reader Sampler now creates a sub-sample for each mail.
> - The supplied TCPClient implementation no longer treats tcp.eolByte=0 as special. To skip EOL checking, set tcp.eolByte=1000 (or some other value which is not a valid byte)
> - JUnit sampler GUI now also finds Test classes defined in user.classpath
> - Leading and trailing spaces are trimmed from variable names in function calls. For example, ${__Random(1,63, LOTTERY )} will use the variable 'LOTTERY' rather than ' LOTTERY '
> - Webservice(SOAP) Sampler can now load local WSDL files using the file: protocol
> - Bug 44872 - Add "All Files" filter to Open File dialogs
> - Mirror server can now be run independently (mirror-server.cmd and mirror-server.sh)
> - Bug 19128 - Added multiple file POST support to HTTP Samplers
> - Allow use of special name LAST to mean the last test run; applies to -t, -l, -j flags
> - Bug 44418 /42178 - CSV Dataset file handling improvements
> - Give BeanShell, Javascript and Jexl functions access to JMeter properties via the "props" object
> - Give BSF Sampler access to JMeter Properties via "props" object
> - Add Jexl as a supported BSF Sampler language
> - Give Beanshell test elements access to JMeter Properties via "props" object
> - Added BSF PreProcessor, PostProcessor and Assertion test elements
> - All BSF elements now have access to System.out via the variable "OUT"
> - Summariser updated to handle variable names
> - Synchronisation added to Summary and Aggregate Report to try to prevent occasional lost samples
> - Bug 44808 , Bug 39641 - Proxy support for binary requests
> - Bug 28502 - HTTP Resource Cache

> ### Non-functional changes

> - Better handling of MirrorServer startup problems and improved unit test.
> - Build process now detects missing 3rd party libraries and reports need for both binary and source archives
> - Skip BeanShell tests if jar is not present
> - Update to Xerces 2.9.1, Xalan 2.7.1, Commons IO 1.4, Commons Lang 2.4, Commons-Logging 1.1.1, XStream 1.3, XPP3 1.1.4c
> - Use properties for log/logn function descriptions
> - Check that all jmx files in the demos directory can be loaded OK
> - Update copyright to 2008; use copy tag instead of numeric character in HTML output
> - Methods called from constructors must not be overridable: make GUI init methods private
> - Make static variables final if possible
> - Split changes into current and previous

> ### Version 2.3.1

> #### Summary of changes

> ##### JMeter Proxy

> The Proxy spoof function was broken in 2.3; it has been fixed. Spoof now supports an optional parameter to limit spoofing to particular URLs. This is useful for HTTPS pages that have insecure content - e.g. images/stylesheets may be accessed using HTTP. Spoofed responses now drop the default port (443) from https links to make them work better.

> Ignored proxy samples are now visible in Listeners - the label is enclosed in [ and ] as an indication. Proxy documentation has been improved.

> ##### GUI changes

> The Add menus show element types in the order in which they are processed - see Test Plan Execution Order . It is no longer possible to add test elements to inappropriate parts of the tree - e.g. samplers cannot be added directly under a test plan. This also applies to Paste and drag and drop.

> The File menu now supports a "Revert" option, which reloads the current file. Also the last few file names used are remembered for easy reloading.

> The Options Menu now supports Collapse All and Expand All items to collapse and expand the test tree.

> ##### Remote testing

> The JMeter server now starts the RMI server directly (by default). This simplifies testing, and means that the RMI server will be stopped when the server stops.

> Functions can now be used in Listener filenames (variables do not work).

> Command-line option -G can now be used to define properties for remote servers. Option -X can be used to stop a remote server after a non-GUI run. Server can be set to automatically exit after a single test (set property server.exitaftertest=true).

> ##### Other enhancements

> JMeter startup no longer loads as many classes; this should reduce memory requirements.

> Parameter and file support added to all BeanShell elements. Javascript function now supports access to JMeter objects; Jexl function always did have access, but the documentation has now been included. New functions __eval() and __evalVar() for evaluating variables.

> CSV files with the correct header column names are now automatically recognised when loaded. There is no need to configure the properties.

> The hostname can now be saved in CSV and XML output files. New "Successes only" option added when saving result files. Errors / Successes only option is now supported when loading XML and CSV files.

> General documentation improvements.

> ##### HTTP

> PUT and DELETE should now work properly. Cookie Manager no longer clears manually entered cookies.

> Now handles the META tag http-equiv charset

> ##### JDBC

> JDBC Sampler now allows INOUT and OUT parameters for Called procedures. JDBC Sampler now allows per-thread connections - set Max Connections = 0 in JDBC Config.

> #### Incompatible changes

> - JMeter server now creates the RMI registry by default. If the RMI registry has already been started externally, this will generate a warning message, but the server will continue. This should not affect JMeter testing. However, if you are also using the RMI registry for other applications there may be problems. For example, when the JMeter server shuts down it will stop the RMI registry. Also user-written command files may need to be adjusted (the ones supplied with JMeter have been updated). To revert to the earlier behaviour, define the JMeter property: server.rmi.create=false .
> - The Proxy server removes If-Modified-Since and If-None-Match headers from generated Header Managers. To revert to the previous behaviour, define the property proxy.headers.remove with no value

> #### Bug fixes

> - Bug 43430 - Count of active threads is incorrect for remote samples
> - Throughput Controller was not working for "all thread" counts
> - If a POST body is built from parameter values only, these are now encoded if the checkbox is set.
> - Bug 43584 - Assertion Failure Message contains a comma that is also used as the delimiter for CSV files
> - HTTP Mirror Server now always returns the exact same content, it used to return incorrect data if UTF-8 encoding was used for HTTP POST body, for example
> - Bug 43612 - HTTP PUT does not honor request parameters
> - Bug 43694 - ForEach Controller (empty collection processing error)
> - Bug 42012 - Variable Listener filenames do not get processed in remote tests. Filenames can now include function references; variable references do not work.
> - Ensure Listener nodes get own save configuration when copy-pasted
> - Correct Proxy Server include and exclude matching description - port and query are included, contrary to previously documented.
> - Aggregate Graph and Aggregate Report Column Header is KB/Sec; fixed the values to be KB rather than bytes
> - Fix SamplingStatCalculator so it no longer adds elapsed time to endTime, as this is handled by SampleResult. This corrects discrepancies between Summary Report and Aggregate Report throughput calculation.
> - Default HTTPSampleResult to ISO-8859-1 encoding
> - Fix default encoding for blank encoding
> - Fix Https spoofing (port problem) which was broken in 2.3
> - Fix HTTP (Java) sampler so http.java.sampler.retries means retries, i.e. does not include initial try
> - Fix SampleResult dataType checking to better detect TEXT documents

> #### Improvements

> - Add run_gui Ant target, to package and then start the JMeter GUI from Ant
> - Add File->Revert to easily drop the current changes and reload the project file currently loaded
> - Bug 31366 - Remember recently opened file(s)
> - Bug 43351 - Add support for Parameters and script file to all BeanShell test elements
> - SaveService no longer needs to instantiate classes
> - New functions: __eval() and __evalVar()
> - Menu items now appear in execution order
> - Test Plan items can now only be dropped/pasted/merged into parts of the tree where they are allowed
> - Property Display to show the value of System and JMeter properties and allow them to be changed
> - Bug 43451 - Allow Regex Extractor to operate on Response Code/Message
> - JDBC Sampler now allows INOUT and OUT parameters for Called procedures
> - JDBC Sampler now allows per-thread connections
> - Cookie Manager not longer clears cookies defined in the GUI
> - HTTP Parameters without names are ignored (except for POST requests with no file)
> - "Save Selection As" added to main menu; now checks only item is selected
> - Test Plan now has Paste menu item (paste was already supported via ^V)
> - If the default delimiter does not work when loading a CSV file, guess the delimiter by analysing the header line.
> - Add optional "loopback" protocol for HttpClient sampler
> - HTTP Mirror Server now supports blocking waiting for more data to appear, if content-length header is present in request
> - HTTP Mirror Server GUI now has the Start and Stop buttons in a more visible place
> - Server mode now creates the RMI registry; to disable set the JMeter property server.rmi.create=false
> - HTTP Sampler now supports using MIME Type field to specify content-type request header when body is constructed from parameter values
> - Enable exit after a single server test - define JMeter property server.exitaftertest=true
> - Added -G option to set properties in remote servers
> - Added -X option to stop remote servers after non-GUI run
> - Bug 43485 - Ability to specify keep-alive on SOAP/XML-RPC request
> - Bug 43678 - Handle META tag http-equiv charset
> - Bug 42555 - [I18N] Proposed corrections for the french translation
> - Bug 43727 - Test Action does not support variables or functions
> - The Proxy server removes If-Modified-Since and If-None-Match headers from generated Header Managers by default. To change the list of removed headers, define the property proxy.headers.remove as a comma-separated list of headers to remove
> - The javaScript function now has access to JMeter variables and context etc. See JavaScript function
> - Use drop-down list for BSF Sampler language field
> - Add hostname to items that can be saved in CSV and XML output files.
> - Errors only flag is now supported when loading XML and CSV files
> - Ensure ResultCollector uses SaveService encoding
> - Proxy now rejects attempts to use it with https
> - Proxy spoofing can now use RE matching to determine which urls to spoof (useful if images are not https)
> - Proxy spoofing now drops the default HTTPS port (443) when converting https: links to http:
> - Add Successes Only logging and display
> - The JMeter log file name is formatted as a SimpleDateFormat (applied to the current date) if it contains paired single-quotes, .e.g. 'jmeter_'yyyyMMddHHmmss'.log'
> - Added Collapse All and Expand All Option menu items
> - Allow optional definition of extra content-types that are viewable as text

> #### Non-functional Improvements

> - Functor code tightened up; Functor can now be used with interfaces, as well as pre-defined targets and parameters.
> - Save graphics function now prompts before overwriting an existing file
> - Debug Sampler and Debug PostProcessor added.
> - Fixed up method names in Calculator and SamplingStatCalculator
> - Tidied up Listener documentation.

> ### Version 2.3

> ### Fixes since 2.3RC4

> #### Bug fixes

> - Fix NPE in SampleResultConverter - XStream PrettyPrintWriter cannot handle nulls
> - If Java HTTP sampler sees null ResponseMessage, replace with HTTP header
> - Bug 43332 - 2.3RC4 does not clear Guis based on TestBean
> - Bug 42948 - Problems with Proxy gui table fields in Java 1.6
> - Fixup broken jmeter-server script
> - Bug 43364 - option to revert If Controller to pre 2.3RC3 behaviour
> - Bug 43449 - Statistical Remote mode does not handle Latency
> - Bug 43450 (partial fix) - Allow SampleCount and ErrorCount to be saved to/restored from files

> #### Improvements

> - Add nameSpace option to XPath extractor
> - Add NULL parameter option to JDBC sampler
> - Add documentation links for Rhino and BeanShell to functions; clarify variables and properties
> - Ensure uncaught exceptions are logged
> - Look for user.properties and system.properties in JMeter bin directory if not found locally

> #### Fixes since 2.3RC3

> - Fixed NPE in Summariser (bug introduced in 2.3RC3)
> - Fixed setup of proxy port (bug introduced in 2.3RC3)
> - Fixed errors when running non-GUI on a headless host (bug introduced in 2.3RC3)
> - Bug 43054 - SSLManager causes stress tests to saturate and crash (bug introduced in 2.3RC3)
> - Clarified HTTP Request Defaults usage of the port field
> - Bug 43006 - NPE if icon.properties file not found
> - Bug 42918 - Size Assertion now treats an empty response as having zero length
> - Bug 43007 - Test ends before all threadgroups started
> - Fix possible NPE in HTTPSampler2 if 302 does not have Location header.
> - Bug 42919 - Failure Message blank in CSV output [now records first non-blank message]
> - Add link to Extending JMeter PDF
> - Allow for quoted charset in Content-Type parsing
> - Bug 39792 - ClientJMeter synchronisation needed
> - Bug 43122 - GUI changes not always picked up when short-cut keys used (bug introduced in 2.3RC3)
> - Bug 42947 - TestBeanGUI changes not picked up when short-cut keys used
> - Added serializer.jar (needed for update to xalan 2.7.0)
> - Bug 38687 - Module controller does not work in non-GUI mode

> #### Improvements since 2.3RC3

> - Add stop thread option to CSV Dataset
> - Updated commons-httpclient to 3.1
> - Bug 28715 - allow variable cookie values (set CookieManager.allow_variable_cookies=false to disable)
> - Bug 40873 - add JMS point-to-point non-persistent delivery option
> - Bug 43283 - Save action adds .jmx if not present; checks for existing file on Save As
> - Control+A key does not work for Save All As; changed to Control+Shift+S
> - Bug 40991 - Allow Assertions to check Headers

> ### Version 2.3RC3

> #### Known problems/restrictions:

> The JMeter remote server does not support multiple concurrent tests - each remote test should be run in a separate server. Otherwise tests may fail with random Exceptions, e.g. ConcurrentModification Exception in StandardJMeterEngine. See Bug 43168 .

> The default HTTP Request (not HTTPClient) sampler may not work for HTTPS connections via a proxy. This appears to be due to a Java bug, see Bug 39337 . To avoid the problem, try a more recent version of Java, or switch to the HTTPClient version of the HTTP Request sampler.

> Transaction Controller parent mode does not support nested Transaction Controllers. Doing so may cause a Null Pointer Exception in TestCompiler.

> Thread active counts are always zero in CSV and XML files when running remote tests.

> The property file_format.testlog=2.1 is treated the same as 2.2. However JMeter does honour the 3 testplan versions.

> Bug 22510 - JMeter always uses the first entry in the keystore.

> Remote mode does not work if JMeter is installed in a directory where the path name contains spaces.

> BeanShell test elements leak memory. This can be reduced by using a file instead of including the script in the test element.

> Variables and functions do not work in Listeners in client-server (remote) mode so they cannot be used to name log files in client-server mode.

> CSV Dataset variables are defined after configuration processing is completed, so they cannot be used for other configuration items such as JDBC Config. (see Bug 40394 )

> #### Summary of changes (for more details, see below)

> Some of the main enhancements are:

> - Htmlparser 2.0 now used for parsing
> - HTTP Authorisation now supports domain and realm
> - HttpClient options can be specified via httpclient.parameters file
> - HttpClient now behaves the same as Java Http for SSL certificates
> - HTTP Mirror Server to allow local testing of HTTP samplers
> - HTTP Proxy supports XML-RPC recording, and other proxy improvements
> - __V() function allows support of nested variable references
> - LDAP Ext sampler optionally parses result sets and supports secure mode
> - FTP Sampler supports Ascii/Binary mode and upload
> - Transaction Controller now optionally generates a Sample with subresults
> - HTTPS session contexts are now per-thread, rather than shared. This gives better emulation of multiple users
> - BeanShell elements now support ThreadListener and TestListener interfaces
> - Coloured icons in Tree View Listener and elsewhere to better differentiate failed samples.

> The main bug fixes are:

> - HTTPS (SSL) handling now much improved
> - Various Remote mode bugs fixed
> - Control+C and Control+V now work in the test tree
> - Latency and Encoding now available in CSV log output
> - Test elements no longer default to previous contents; test elements no longer cleared when changing language.

> #### Incompatible changes (usage):

> N.B. The javax.net.ssl properties have been moved from jmeter.properties to system.properties, and will no longer work if defined in jmeter.properties.
> The new arrangement is more flexible, as it allows arbitrary system properties to be defined.

> SSL session contexts are now created per-thread, rather than being shared. This generates a more realistic load for HTTPS tests. The change is likely to slow down tests with many SSL threads. The original behaviour can be enabled by setting the JMeter property:

>     https.sessioncontext.shared=true

> The LDAP Extended Sampler now uses the same panel for both Thread Bind and Single-Bind tests. This means that any tests using the Single-bind test will need to be updated to set the username and password.

> Bug 41140 : JMeterThread behaviour was changed so that PostProcessors are run in forward order (as they appear in the test plan) rather than reverse order as previously. The original behaviour can be restored by setting the following JMeter property:
> jmeterthread.reversePostProcessors=true

> The HTTP Authorisation Manager now has extra columns for domain and realm, so the temporary work-round of using '\' and '@' in the username to delimit the domain and realm has been removed.

> Control-Z no longer used for Remote Start All - this now uses Control+Shift+R

> HttpClient now uses pre-emptive authentication. This can be changed by setting the following:

>     jmeter.properties:
>     httpclient.parameters.file=httpclient.parameters

>     httpclient.parameters:
>     http.authentication.preemptive$Boolean=false

> The port field in HTTP Request Defaults is no longer ignored for https samplers if it is set to 80.

> #### Incompatible changes (development):

> N.B. The clear() method was defined in the following interfaces: Clearable, JMeterGUIComponent and TestElement. The methods serve different purposes, so two of them were renamed: the Clearable method is now clearData() and the JMeterGUIComponent method is now clearGui(). 3rd party add-ons may need to be rebuilt.

> Calulator and SamplingStatCalculator classes no longer provide any formatting of their data. Formatting should now be done using the jorphan.gui Renderer classes.

> Removed deprecated method JMeterUtils.split() - use JOrphanUtils version instead.

> Removed method saveUsingJPEGEncoder() from SaveGraphicsService. It was unused so far, and used the only Sun-specific class in JMeter.

> #### New functionality/improvements:

> - Add Domain and Realm support to HTTP Authorisation Manager
> - HttpClient now behaves the same as the JDK http sampler for invalid certificates etc
> - Added httpclient.parameters.file to allow HttpClient parameters to be defined
> - Bug 33964 - Http Requests can send a file as the entire post body if name/type are omitted
> - Bug 41705 - add content-encoding option to HTTP samplers for POST requests
> - Bug 40933 , Bug 40945 - optional RE matching when retrieving embedded resource URLs
> - Bug 27780 - (patch 19936) create multipart/form-data HTTP request without uploading file
> - Bug 42098 - Use specified encoding for parameter values in HTTP GET
> - Bug 42506 - JMeter threads now use independent SSL sessions
> - Bug 41707 - HTTP Proxy XML-RPC support
> - Bug 41880 - Add content-type filtering to HTTP Proxy Server
> - Bug 41876 - Add more options to control what the HTTP Proxy generates
> - Bug 42158 - Improve support for multipart/form-data requests in HTTP Proxy server
> - Bug 42173 - Let HTTP Proxy handle encoding of request, and undecode parameter values
> - Bug 42674 - default to pre-emptive HTTP authorisation if not specified
> - Support "file" protocol in HTTP Samplers
> - Http Autoredirects are now enabled by default when creating new samplers
> - Bug 40103 - various LDAP enhancements
> - Bug 40369 - LDAP: Stable search results in sampler
> - Bug 40381 - LDAP: more descriptive strings
> - BeanShell Post-Processor no longer ignores samples with zero-length result data
> - Added beanshell.init.file property to run a BeanShell script at startup
> - Bug 39864 - BeanShell init files now found from currrent or bin directory
> - BeanShell elements now support ThreadListener and TestListener interfaces
> - BSF Sampler passes additional variables to the script
> - Added timeout for WebService (SOAP) Sampler
> - Bug 40825 - Add JDBC prepared statement support
> - Extend JDBC Sampler: Commit, Rollback, AutoCommit
> - Bug 41457 - Add TCP Sampler option to not re-use connections
> - Bug 41522 - Use JUnit sampler name in sample results
> - Bug 42223 - FTP Sampler can now upload files
> - Bug 40804 - Change Counter default to max = Long.MAX_VALUE
> - Use property jmeter.home (if present) to override user.dir when starting JMeter
> - New -j option to easily change jmeter log file
> - HTTP Mirror Server Workbench element
> - Bug 41253 - extend XPathExtractor to work with non-NodeList XPath expressions
> - Bug 42088 - Add XPath Assertion for booleans
> - Added __V variable function to resolve nested variable names
> - Bug 40369 - Equals Response Assertion
> - Bug 41704 - Allow charset encoding to be specified for CSV DataSet
> - Bug 41259 - Comment field added to all test elements
> - Add standard deviation to Summary Report
> - Bug 41873 - Add name to AssertionResult and display AssertionResult in ViewResultsFullVisualizer
> - Bug 36755 - Save XML test files with UTF-8 encoding
> - Use ISO date-time format for Tree View Listener (previously the year was not shown)
> - Improve loading of CSV files: if possible, use header to determine format; guess timestamp format if not milliseconds
> - Bug 41913 - TransactionController now creates samples as sub-samples of the transaction
> - Bug 42582 - JSON pretty printing in Tree View Listener
> - Bug 40099 - Enable use of object variable in ForEachController
> - Bug 39693 - View Result Table uses icon instead of check box
> - Bug 39717 - use icons in the results tree
> - Bug 42247 - improve HCI
> - Allow user to cancel out of Close dialogue

> #### Non-functional improvements:

> - Functor calls can now be unit tested
> - Replace com.sun.net classes with javax.net
> - Extract external jar definitions into build.properties file
> - Use specific jar names in build classpaths so errors are detected sooner
> - Tidied up ORO calls; now only one cache, size given by oro.patterncache.size, default 1000
> - Bug 42326 - Order of elements in .jmx files changes

> #### External jar updates:

> - Htmlparser 2.0-20060923
> - xstream 1.2.1/xpp3_min-1.1.3.4.O
> - Batik 1.6
> - BSF 2.4.0
> - commons-collections 3.2
> - commons-httpclient-3.1-rc1
> - commons-jexl 1.1
> - commons-lang-2.3 (added)
> - JUnit 3.8.2
> - velocity 1.5
> - commons-io 1.3.1 (added)

> #### Bug fixes:

> - Bug 39773 - NTLM now needs local host name - fix other call
> - Bug 40438 - setting "httpclient.localaddress" has no effect
> - Bug 40419 - Chinese messages translation fix
> - Bug 39861 - fix typo
> - Bug 40562 - redirects no longer invoke RE post processors
> - Bug 40451 - set label if not set by sampler
> - Fix NPE in CounterConfig.java in Remote mode
> - Bug 40791 - Calculator used by Summary Report
> - Bug 40772 - correctly parse missing fields in CSV log files
> - Bug 40773 - XML log file timestamp not parsed correctly
> - Bug 41029 - JMeter -t fails to close input JMX file
> - Bug 40954 - Statistical mode in distributed testing shows wrong results
> - Fix ClassCast Exception when using sampler that returns null, e..g TestAction
> - Bug 41140 - Post-processors are run in reverse order
> - Bug 41277 - add Latency and Encoding to CSV output
> - Bug 41414 - Mac OS X may add extra item to -jar classpath
> - Fix NPE when saving thread counts in remote testing
> - Bug 34261 - NPE in HtmlParser (allow for missing attributes)
> - Bug 40100 - check FileServer type before calling close
> - Bug 39887 - jmeter.util.SSLManager: Couldn't load keystore error message
> - Bug 41543 - exception when webserver returns "500 Internal Server Error" and content-length is 0
> - Bug 41416 - don't use chunked input for text-box input in SOAP-RPC sampler
> - Bug 39827 - SOAP Sampler content length for files
> - Fix Class cast exception in Clear.java
> - Bug 40383 - don't set content-type if already set
> - Mailer Visualiser test button now works if test plan has not yet been saved
> - Bug 36959 - Shortcuts "ctrl c" and "ctrl v" don't work on the tree elements
> - Bug 40696 - retrieve embedded resources from STYLE URL() attributes
> - Bug 41568 - Problem when running tests remotely when using a 'Counter'
> - Fixed various classes that assumed timestamps were always end time stamps:
>   - SamplingStatCalculator
>   - JTLData
>   - RunningSample
> - Bug 40325 - allow specification of proxyuser and proxypassword for WebServiceSampler
> - Change HttpClient proxy definition to use NTCredentials; added http.proxyDomain property for this
> - Bug 40371 - response assertion "pattern to test" scrollbar problem
> - Bug 40589 - Unescape XML entities in embedded URLs
> - Bug 41902 - NPE in HTTPSampler when responseCode = -1
> - Bug 41903 - ViewResultsFullVisualizer : status column looks bad when you do copy and paste
> - Bug 41837 - Parameter value corruption in proxy
> - Bug 41905 - Can't cut/paste/select Header Manager fields in Java 1.6
> - Bug 41928 - Make all request headers sent by HTTP Request sampler appear in sample result
> - Bug 41944 - Subresults not handled recursively by ResultSaver
> - Bug 42022 - HTTPSampler does not allow multiple headers of same name
> - Bug 42019 - Content type not stored in redirected HTTP request with subresults
> - Bug 42057 - connection can be null if method is null
> - Bug 41518 - JMeter changes the HTTP header Content Type for POST request
> - Bug 42156 - HTTPRequest HTTPClient incorrectly urlencodes parameter value in POST
> - Bug 42184 - Number of bytes for subsamples not added to sample when sub samples are added
> - Bug 42185 - If a HTTP Sampler follows a redirect, and is set up to download images, then images are downloaded multiple times
> - Bug 39808 - Invalid redirect causes incorrect sample time
> - Bug 42267 - Concurrent GUI update failure in Proxy Recording
> - Bug 30120 - Name of simple controller is resetted if a new simple controller is added as child
> - Bug 41078 - merge results in name change of test plan
> - Bug 40077 - Creating new Elements copies values from Existing elements
> - Bug 42325 - Implement the "clear" method for the LogicControllers
> - Bug 25441 - TestPlan changes sometimes detected incorrectly (isDirty)
> - Bug 39734 - Listeners shared after copy/paste operation
> - Bug 40851 - Loop controller with 0 iterations, stops evaluating the iterations field
> - Bug 24684 - remote startup problems if spaces in the path of the jmeter
> - Use Listener configuration when loading CSV data files
> - Function methods setParameters() need to be synchronized
> - Fix CLI long optional argument to require "=" (as for short options)
> - Fix SlowSocket to work properly with Httpclient (both http and https)
> - Bug 41612 - Loop nested in If Controller behaves erratically
> - Bug 42232 - changing language clears UDV contents
> - Jexl function did not allow variables

> ### Version 2.2

> #### Incompatible changes:

> The time stamp is now set to the sampler start time (it was the end). To revert to the previous behaviour, change the property sampleresult.timestamp.start to false (or comment it)

> The JMX output format has been simplified and files are not backwards compatible

> The JMeter.BAT file no longer changes directory to JMeter home, but runs from the current working directory. The jmeter-n.bat and jmeter-t.bat files change to the directory containing the input file.

> Listeners are now started slightly later in order to allow variable names to be used. This may cause some problems; if so define the following in jmeter.properties:
> jmeterengine.startlistenerslater=false

> The GUI now expands the tree by default when loading a test plan. This can be disabled by setting the JMeter property onload.expandtree=false

> #### Known problems:

> - Post-processors run in reverse order (see Bug 41140 )
> - Module Controller does not work in non-GUI mode
> - Aggregate Report and some other listeners use increasing amounts of memory as a test progresses
> - Does not always handle non-default encoding properly
> - Spaces in the installation path cause problems for client-server mode
> - Change of Language does not propagate to all test elements
> - SamplingStatCalculator keeps a List of all samples for calculation purposes; this can cause memory exhaustion in long-running tests
> - Does not properly handle server certificates if they are expired or not installed locally

> #### New functionality:

> - Report function
> - XPath Extractor Post-Processor. Handles single and multiple matches.
> - Simpler JMX file format (2.2)
> - BeanshellSampler code can update ResponseData directly
> - Bug 37490 - Allow UDV as delay in Duration Assertion
> - Slow connection emulation for HttpClient
> - Enhanced JUnitSampler so that by default assert errors and exceptions are not appended to the error message. Users must explicitly check append in the sampler
> - Enhanced the documentation for webservice sampler to explain how it works with CSVDataSet
> - Enhanced the documentation for javascript function to explain escaping comma
> - Allow CSV Data Set file names to be absolute
> - Report Tree compiler errors better
> - Don't reset Regex Extractor variable if default is empty
> - includecontroller.prefix property added
> - Regular Expression Extractor sets group count
> - Can now save entire screen as an image, not just the right-hand pane
> - Bug 38901 - Add optional SOAPAction header to SOAP Sampler
> - New BeanShell test elements: Timer, PreProcessor, PostProcessor, Listener
> - __split() function now clears next variable, so it can be used with ForEach Controller
> - Bug 38682 - add CallableStatement functionality to JDBC Sampler
> - Make it easier to change the RMI/Server port
> - Add property jmeter.save.saveservice.xml_pi to provide optional xml processing instruction in JTL files
> - Add bytes and URL to items that can be saved in sample log files (XML and CSV)
> - The Post-Processor "Save Responses to a File" now saves the generated file name with the sample, and the file name can be included in the sample log file.
> - Change jmeter.bat DOS script so it works from any directory
> - New -N option to define nonProxyHosts from command-line
> - New -S option to define system properties from input file
> - Bug 26136 - allow configuration of local address
> - Expand tree by default when loading a test plan - can be disabled by setting property onload.expandtree=false
> - Bug 11843 - URL Rewriter can now cache the session id
> - Counter Pre-Processor now supports formatted numbers
> - Add support for HEAD PUT OPTIONS TRACE and DELETE methods
> - Allow default HTTP implementation to be changed
> - Optionally save active thread counts (group and all) to result files
> - Variables/functions can now be used in Listener file names
> - New __time() function; define START.MS/START.YMD/START.HMS properties and variables
> - Add Thread Name to Tree and Table Views
> - Add debug functions: What class, debug on, debug off
> - Non-caching Calculator - used by Table Visualiser to reduce memory footprint
> - Summary Report - similar to Aggregate Report, but uses less memory
> - Bug 39580 - recycle option for CSV Dataset
> - Bug 37652 - support for Ajp Tomcat protocol
> - Bug 39626 - Loading SOAP/XML-RPC requests from file
> - Bug 39652 - Allow truncation of labels on AxisGraph
> - Allow use of htmlparser 1.6
> - Bug 39656 - always use SOAP action if it is provided
> - Automatically include properties from user.properties file
> - Add __jexl() function - evaluates Commons JEXL expressions
> - Optionally load JMeter properties from user.properties and system properties from system.properties.
> - Bug 39707 - allow Regex match against URL
> - Add start time to Table Visualiser
> - HTTP Samplers can now extract embedded resources for any required media types

> #### Bug fixes:

> - Fix NPE when no module selected in Module Controller
> - Fix NPE in XStream when no ResponseData present
> - Remove ?xml prefix when running with Java 1.5 and no x-jars
> - Bug 37117 - setProperty() function should return ""; added optional return of original setting
> - Fix CSV output time format
> - Bug 37140 - handle encoding better in RegexFunction
> - Load all cookies, not just the first; fix class cast exception
> - Fix default Cookie path name (remove page name)
> - Fixed resultcode attribute name
> - Bug 36898 - apply encoding to RegexExtractor
> - Add properties for saving subresults, assertions, latency, samplerData, responseHeaders, requestHeaders & encoding
> - Bug 37705 - Synch Timer now works OK after run is stopped
> - Bug 37716 - Proxy request now handles file Post correctly
> - HttpClient Sampler now saves latency
> - Fix NPE when using JavaScript function on Test Plan
> - Fix Base Href parsing in htmlparser
> - Bug 38256 - handle cookie with no path
> - Bug 38391 - use long when accumulating timer delays
> - Bug 38554 - Random function now uses long numbers
> - Bug 35224 - allow duplicate attributes for LDAP sampler
> - Bug 38693 - Webservice sampler can now use https protocol
> - Bug 38646 - Regex Extractor now clears old variables on match failure
> - Bug 38640 - fix WebService Sampler pooling
> - Bug 38474 - HTML Link Parser doesn't follow frame links
> - Bug 36430 - Counter now uses long rather than int to increase the range
> - Bug 38302 - fix XPath function
> - Bug 38748 - JDBC DataSourceElement fails with remote testing
> - Bug 38902 - sometimes -1 seems to be returned unnecessarily for response code
> - Bug 38840 - make XML Assertion thread-safe
> - Bug 38681 - Include controller now works in non-GUI mode
> - Add write(OS,IS) implementation to TCPClientImpl
> - Sample Result converter saves response code as "rc". Previously it saved as "rs" but read with "rc"; it will now also read with "rc". The XSL stylesheets also now accept either "rc" or "rs"
> - Fix counter function so each counter instance is independent (previously the per-user counters were shared between instances of the function)
> - Fix TestBean Examples so that they work
> - Fix JTidy parser so it does not skip body tags with background images
> - Fix HtmlParser parser so it catches all background images
> - Bug 39252 set SoapSampler sample result from XML data
> - Bug 38694 - WebServiceSampler not setting data encoding correctly
> - Result Collector now closes input files read by listeners
> - Bug 25505 - First HTTP sampling fails with "HTTPS hostname wrong: should be 'localhost'"
> - Bug 25236 - remove double scrollbar from Assertion Result Listener
> - Bug 38234 - Graph Listener divide by zero problem
> - Bug 38824 - clarify behaviour of Ignore Status
> - Bug 38250 - jmeter.properties "language" now supports country suffix, for zh_CN and zh_TW etc
> - jmeter.properties file is now closed after it has been read
> - Bug 39533 - StatCalculator added wrong items
> - Bug 39599 - ConcurrentModificationException
> - HTTPSampler2 now handles Auto and Follow redirects correctly
> - Bug 29481 - fix reloading sample results so subresults not counted twice
> - Bug 30267 - handle AutoRedirects properly
> - Bug 39677 - allow for space in JMETER_BIN variable
> - Use Commons HttpClient cookie parsing and management. Fix various problems with cookie handling.
> - Bug 39773 - NTCredentials needs host name

> #### Other changes

> - Updated to HTTPClient 3.0 (from 2.0)
> - Updated to Commons Collections 3.1
> - Improved formatting of Request Data in Tree View
> - Expanded user documentation
> - Added MANIFEST, NOTICE and LICENSE to all jars
> - Extract htmlparser interface into separate jarfile to make it possible to replace the parser
> - Removed SQL Config GUI as no longer needed (or working!)
> - HTTPSampler no longer logs a warning for Page not found (404)
> - StringFromFile now callable as __StringFromFile (as well as _StringFromFile)
> - Updated to Commons Logging 1.1

> ### Version 2.1.1

> #### New functionality:

> - New Include Controller allows a test plan to reference an external jmx file
> - New JUnitSampler added for using JUnit Test classes
> - New Aggregate Graph listener is capable of graphing aggregate statistics
> - Can provide additional classpath entries using the property user.classpath and on the Test Plan element

> #### Bug fixes:

> - AccessLog Sampler and JDBC test elements populated correctly from 2.0 test plans
> - BSF Sampler now populates filename and parameters from saved test plan
> - Bug 36500 - handle missing data more gracefully in WebServiceSampler
> - Bug 35546 - add merge to right-click menu
> - Bug 36642 - Summariser stopped working in 2.1
> - Bug 36618 - CSV header line did not match saved data
> - JMeter should now run under JVM 1.3 (but does not build with 1.3)

> ### Version 2.1

> #### New functionality:

> - New Test Script file format - smaller, more compact, more readable
> - New Sample Result file format - smaller, more compact
> - XSchema Assertion
> - XML Tree display
> - CSV DataSet Config item
> - New JDBC Connection Pool Config Element
> - Synchronisation Timer
> - setProperty function
> - Save response data on error
> - Ant JMeter XSLT now optionally shows failed responses and has internal links
> - Allow JavaScript variable name to be omitted
> - Changed following Samplers to set sample label from sampler name
> - All Test elements can be saved as a graphics image to a file
> - Bug 35026 - add RE pattern matching to Proxy
> - Bug 34739 - Enhance constant Throughput timer
> - Bug 25052 - use response encoding to create comparison string in Response Assertion
> - New optional icons
> - Allow icons to be defined via property files
> - New stylesheets for 2.1 format XML test output
> - Save samplers, config element and listeners as PNG
> - Enhanced support for WSDL processing
> - New JMS sampler for topic and queue messages
> - How-to for JMS samplers
> - Bug 35525 - Added Spanish localisation
> - Bug 30379 - allow server.rmi.port to be overridden
> - enhanced the monitor listener to save the calculated stats
> - Functions and variables now work at top level of test plan

> #### Bug fixes:

> - Bug 34586 - XPath always remained as /
> - BeanShellInterpreter did not handle null objects properly
> - Fix Chinese resource bundle names
> - Save field names if required to CSV files
> - Ensure XML file is closed
> - Correct icons now displayed for TestBean components
> - Allow for missing optional jar(s) in creating menus
> - Changed Samplers to set sample label from sampler name as was the case for HTTP
> - Fix various samplers to avoid NPEs when incomplete data is provided
> - Fix Cookie Manager to use seconds; add debug
> - Bug 35067 - set up filename when using -t option
> - Don't substitute TestElement.* properties by UDVs in Proxy
> - Bug 35065 - don't save old extensions in File Saver
> - Bug 25413 - don't enable Restart button unnecessarily
> - Bug 35059 - Runtime Controller stopped working
> - Clear up any left-over connections created by LDAP Extended Sampler
> - Bug 23248 - module controller didn't remember stuff between save and reload
> - Fix Chinese locales
> - Bug 29920 - change default locale if necessary to ensure default properties are picked up when English is selected.
> - Bug fixes for Tomcat monitor captions
> - Fixed webservice sampler so it works with user defined variables
> - Fixed screen borders for LDAP config GUI elements
> - Bug 31184 - make sure encoding is specified in JDBC sampler
> - TCP sampler - only share sockets with same host:port details; correct the manual
> - Extract src attribute for embed tags in JTidy and Html Parsers

> ### Version 2.0.3

> #### New functionality:

> - XPath Assertion and XPath Function
> - Switch Controller
> - ForEach Controller can now loop through sets of groups
> - Allow CSVRead delimiter to be changed (see jmeter.properties)
> - Bug 33920 - allow additional property files
> - Bug 33845 - allow direct override of Home dir

> #### Bug fixes:

> - Regex Extractor nested constant not put in correct place Bug 32395
> - Start time reset to now if necessary so that delay works OK.
> - Missing start/end times in scheduler are assumed to be now, not 1970
> - Bug 28661 - 304 responses not appearing in listeners
> - DOS scripts now handle different disks better
> - Bug 32345 - HTTP Rewriter does not work with HTTP Request default
> - Catch Runtime Exceptions so an error in one Listener does not affect others
> - Bug 33467 - __threadNum() extracted number wrongly
> - Bug 29186 ,33299 - fix CLI parsing of "-" in second argument
> - Fix CLI parse bug: -D arg1=arg2. Log more startup parameters.
> - Fix JTidy and HTMLParser parsers to handle form src= and link rel=stylesheet
> - JMeterThread now logs Errors to jmeter.log which were appearing on console
> - Ensure WhileController condition is dynamically checked
> - Bug 32790 ensure If Controller condition is re-evaluated each time
> - Bug 30266 - document how to display proxy recording responses
> - Bug 33921 - merge should not change file name
> - Close file now gives chance to save changes
> - Bug 33559 - fixes to Runtime Controller

> #### Other changes:

> - To help with variable evaluation, JMeterThread sets "sampling started" a bit earlier (see jmeter.properties)
> - Bug 33796 - delete cookies with null/empty values
> - Better checking of parameter count in JavaScript function
> - Thread Group now defaults to 1 loop instead of forever
> - All Beanshell access is now via a single class; only need BSH jar at run-time
> - Bug 32464 - document Direct Draw settings in jmeter.bat
> - Bug 33919 - increase Counter field sizes
> - Bug 32252 - ForEach was not initialising counters

> ### Version 2.0.2

> #### New functionality:

> - While Controller
> - BeanShell intilisation scripts
> - Result Saver can optionally save failed results only
> - Display as HTML has option not to download frames and images etc
> - Multiple Tree elements can now be enabled/disabled/copied/pasted at once
> - __split() function added
> - Bug 28699 allow Assertion to regard unsuccessful responses - e.g. 404 - as successful
> - Bug 29075 Regex Extractor can now extract data out of http response header as well as the body
> - __log() functions can now write to stdout and stderr
> - URL Modifier can now optionally ignore query parameters

> #### Bug fixes:

> - If controller now works after the first false condition Bug 31390
> - Regex GUI was losing track of Header/Body checkbox Bug 29853
> - Display as HTML now handles frames and relative images
> - Right-click open replaced by merge
> - Fix some drag and drop problems
> - Fixed foreach demo example so it works
> - Bug 30741 SSL password prompt now works again
> - StringFromFile now closes files at end of test; start and end now optional as intended
> - Bug 31342 Fixed text of SOAP Sampler headers
> - Proxy must now be stopped before it can be removed Bug 25145
> - Link Parser now supports BASE href Bug 25490
> - Bug 30917 Classfinder ignores duplicate names
> - Bug 22820 Allow Counter value to be cleared
> - Bug 28230 Fix NPE in HTTP Sampler retrieving embedded resources
> - Improve handling of StopTest; catch and log some more errors
> - ForEach Controller no longer runs any samples if first variable is not defined
> - Bug 28663 NPE in remote JDBC execution
> - Bug 30110 Deadlock in stopTest processing
> - Bug 31696 Duration not working correctly when using Scheduler
> - JMeterContext now uses ThreadLocal - should fix some potential NPE errors

> ### Version 2.0.1

> Bug fix release. TBA.

> ### Version 2.0

> - HTML parsing improved; now has choice of 3 parsers, and most embedded elements can now be detected and downloaded.
> - Redirects can now be delegated to URLConnection by defining the JMeter property HTTPSamper.delegateRedirects=true (default is false)
> - Stop Thread and Stop Test methods added for Samplers and Assertions etc. Samplers can call setStopThread(true) or setStopTest(true) if they detect an error that needs to stop the thread of the test after the sample has been processed
> - Thread Group Gui now has an extra pane to specify what happens after a Sampler error: Continue (as now), Stop Thread or Stop Test. This needs to be extended to a lower level at some stage.
> - Added Shutdown to Run Menu. This is the same as Stop except that it lets the Threads finish normally (i.e. after the next sample has been completed)
> - Remote samples can be cached until the end of a test by defining the property hold_samples=true when running the server. More work is needed to be able to control this from the GUI
> - Proxy server has option to skip recording browser headers
> - Proxy restart works better (stop waits for daemon to finish)
> - Scheduler ignores start if it has already passed
> - Scheduler now has delay function
> - added Summariser test element (mainly for non-GUI) testing. This prints summary statistics to System.out and/or the log file every so oftem (3 minutes by default). Multiple summarisers can be used; samples are accumulated by summariser name.
> - Extra Proxy Server options: Create all samplers with keep-alive disabled Add Separator markers between sets of samples Add Response Assertion to first sampler in each set
> - Test Plan has a comment field
> - Help Page can now be pushed to background
> - Separate Function help page
> - New / amended functions
> - __property() and __P() functions
> - __log() and __logn() - for writing to the log file
> - _StringFromFile can now process a sequence of files, e.g. dir/file01.txt, dir/file02.txt etc
> - _StringFromFile() funtion can now use a variable or function for the file name
> - New / amended Assertions
> - Response Assertion now works for URLs, and it handles null data better
> - Response Assertion can now match on Response Code and Response message as well
> - HTML Assertion using JTidy to check for well-formed HTML
> - If Controller (not fully functional yet)
> - Transaction Controller (aggregates the times of its children)
> - New Samplers
> - Basic BSF Sampler (optional)
> - BeanShell Sampler (optional, needs to be downloaded from www.beanshell.org
> - Basic TCP Sampler
> - Optionally start BeanShell server (allows remote access to JMeter variables and methods)

> ### Version 1.9.1

> TBA

> ### Version 1.9

> - Sample result log files can now be in CSV or XML format
> - New Event model for notification of iteration events during test plan run
> - New Javascript function for executing arbitrary javascript statements
> - Many GUI improvements
> - New Pre-processors and Post-processors replace Modifiers and Response-Based Modifiers.
> - Compatible with jdk1.3
> - JMeter functions are now fully recursive and universal (can use functions as parameters to functions)
> - Integrated help window now supports hypertext links
> - New Random Function
> - New XML Assertion
> - New LDAP Sampler (alpha code)
> - New Ant Task to run JMeter (in extras folder)
> - New Java Sampler test implementation (to assist developers)
> - More efficient use of memory, faster loading of .jmx files
> - New SOAP Sampler (alpha code)
> - New Median calculation in Graph Results visualizer
> - Default config element added for developer benefit
> - Various performance enhancements during test run
> - New Simple File recorder for minimal GUI overhead during test run
> - New Function: StringFromFile - grabs values from a file
> - New Function: CSVRead - grabs multiple values from a file
> - Functions now longer need to be encoded - special values should be escaped with "\" if they are literal values
> - New cut/copy/paste functionality
> - SSL testing should work with less user-fudging, and in non-gui mode
> - Mailer Model works in non-gui mode
> - New Througput Controller
> - New Module Controller
> - Tests can now be scheduled to run from a certain time till a certain time
> - Remote JMeter servers can be started from a non-gui client. Also, in gui mode, all remote servers can be started with a single click
> - ThreadGroups can now be run either serially or in parallel (default)
> - New command line options to override properties
> - New Size Assertion

> ### Version 1.8.1

> - Bug Fix Release. Many bugs were fixed.
> - Removed redundant "Root" node from test tree.
> - Re-introduced Icons in test tree.
> - Some re-organization of code to improve build process.
> - View Results Tree has added option to view results as web document (still buggy at this point).
> - New Total line in Aggregate Listener (still buggy at this point).
> - Improvements to ability to change JMeter's Locale settings.
> - Improvements to SSL Manager.

> ### Version 1.8

> - Improvement to Aggregate report's calculations.
> - Simplified application logging.
> - New Duration Assertion.
> - Fixed and improved Mailer Visualizer.
> - Improvements to HTTP Sampler's recovery of resources (sockets and file handles).
> - Improving JMeter's internal handling of test start/stop.
> - Fixing and adding options to behavior of Interleave and Random Controllers.
> - New Counter config element.
> - New User Parameters config element.
> - Improved performance of file opener.
> - Functions and other elements can access global variables.
> - Help system available within JMeter's GUI.
> - Test Elements can be disabled.
> - Language/Locale can be changed while running JMeter (mostly).
> - View Results Tree can be configured to record only errors.
> - Various bug fixes.

> ### Version 1.7.3

> - New Functions that provide more ability to change requests dynamically during test runs.
> - New language translations in Japanese and German.
> - Removed annoying Log4J error messages.
> - Improved support for loading JMeter 1.7 version test plan files (.jmx files).
> - JMeter now supports proxy servers that require username/password authentication.
> - Dialog box indicating test stopping doesn't hang JMeter on problems with stopping test.
> - GUI can run multiple remote JMeter servers (fixes GUI bug that prevented this).
> - Dialog box to help created function calls in GUI.
> - New Keep-alive switch in HTTP Requests to indicate JMeter should or should not use Keep-Alive for sockets.
> - HTTP Post requests can have GET style arguments in Path field. Proxy records them correctly now.
> - New User-defined test-wide static variables.
> - View Results Tree now displays more information, including name of request (matching the name in the test tree) and full request and POST data.
> - Removed obsolete View Results Visualizer (use View Results Tree instead).
> - Performance enhancements.
> - Memory use enhancements.
> - Graph visualizer GUI improvements.
> - Updates and fixes to Mailer Visualizer.

> ### Version 1.7.2

> - JMeter now notifies user when test has stopped running.
> - HTTP Proxy server records HTTP Requests with re-direct turned off.
> - HTTP Requests can be instructed to either follow redirects or ignore them.
> - Various GUI improvements.
> - New Random Controller.
> - New SOAP/XML-RPC Sampler.

> ### Version 1.7.1

> - JMeter's architecture revamped for a more complete separation between GUI code and test engine code.
> - Use of Avalon code to save test plans to XML as Configuration Objects
> - All listeners can save data to file and load same data at later date.

> ### Version 1.7Beta

> - Better XML support for special characters (Tushar Bhatia)
> - Non-GUI functioning & Non-GUI test plan execution (Tushar Bhatia)
> - Removing Swing dependence from base JMeter classes
> - Internationalization (Takashi Okamoto)
> - AllTests bug fix (neth6@atozasia.com)
> - ClassFinder bug fix (neth6@atozasia.com)
> - New Loop Controller
> - Proxy Server records HTTP samples from browser (and documented in the user manual)
> - Multipart Form support
> - HTTP Header class for Header customization
> - Extracting HTTP Header information from responses (Jamie Davidson)
> - Mailer Visualizer re-added to JMeter
> - JMeter now url encodes parameter names and values
> - listeners no longer give exceptions if their gui's haven't been initialized
> - HTTPS and Authorization working together
> - New Http sampling that automatically parses HTML response for images to download, and includes the downloading of these images in total time for request (Neth neth6@atozasia.com)
> - HTTP responses from server can be parsed for links and forms, and dynamic data can be extracted and added to test samples at run-time (documented)
> - New Ramp-up feature (Jonathan O'Keefe)
> - New visualizers (Neth)
> - New Assertions for functional testing

> ### Version 1.6.1

> - Fixed saving and loading of test scripts (no more extra lines)
> - Can save and load special characters (such as "&" and "<").
> - Can save and load timers and listeners.
> - Minor bug fix for cookies (if you cookie value contained an "=", then it broke).
> - URL's can sample ports other than 80, and can test HTTPS, provided you have the necessary jars (JSSE)

> ### Version 1.6 Alpha

> - New UI
> - Separation of GUI and Logic code
> - New Plug-in framework for new modules
> - Enhanced performance
> - Layering of test logic for greater flexibility
> - Added support for saving of test elements
> - Added support for distributed testing using a single client

> ### Version 1.5.1

> - Fixed bug that caused cookies not to be read if header name case not as expected.
> - Clone entries before sending to sampler - prevents relocations from messing up information across threads
> - Minor bug fix to convenience dialog for adding paramters to test sample. Bug prevented entries in dialog from appearing in test sample.
> - Added xerces.jar to distribution
> - Added junit.jar to distribution and created a few tests.
> - Started work on new framework. New files in cvs, but do not effect program yet.
> - Fixed bug that prevent HTTPJMeterThread from delaying according to chosen timer.

> ### Version 1.5

> - Abstracted out the concept of the Sampler, SamplerController, and TestSample. A Sampler represents code that understands a protocol (such as HTTP, or FTP, RMI, SMTP, etc..). It is the code that actually makes the connection to whatever is being tested. A SamplerController represents code that understands how to organize and run a group of test samples. It is what binds together a Sampler and its test samples and runs them. A TestSample represents code that understands how to gather information from the user about a particular test. For a website, it would represent a URL and any information to be sent with the URL.
> - The UI has been updated to make entering test samples more convenient.
> - Thread groups have been added, allowing a user to setup multiple test to run concurrently, and to allow sharing of test samples between those tests.
> - It is now possible to save and load test samples.
> - ....and many more minor changes/improvements...

> Apache JMeter 1.4.1-dev

> - Cleaned up URLSampler code after tons of patches for better readability. (SM)
> - Made JMeter send a special "user-agent" identifier. (SM)
> - Fixed problems with redirection not sending cookies and authentication info and removed a warning with jikes compilation. Thanks to Wesley Tanaka for the patches (SM)
> - Fixed a bug in the URLSampler that caused to skip one URL when testing lists of URLs and a problem with Cookie handling. Thanks to Graham Johnson for the patches (SM)
> - Fixed a problem with POST actions. Thanks to Stephen Schaub for the patch (SM)

> Apache JMeter 1.4 - Jul 11 1999

> - Fixed a problem with POST actions. Thanks to Brendan Burns for the patch (SM)
> - Added close button to the About box for those window managers who don't provide it. Thanks to Jan-Henrik Haukeland for pointing it out. (SM)
> - Added the simple Spline sample visualizer (JPN)

> Apache JMeter 1.3 - Apr 16 1999

> - Run the Garbage Collector and run finalization before starting to sampling to ensure same state every time (SM)
> - Fixed some NullPointerExceptions here and there (SM)
> - Added HTTP authentication capabilities (RL)
> - Added windowed sample visualizer (SM)
> - Fixed stupid bug for command line arguments. Thanks to Jorge Bracer for pointing this out (SM)

> Apache JMeter 1.2 - Mar 17 1999

> - Integrated cookie capabilities with JMeter (SM)
> - Added the Cookie manager and Netscape file parser (SD)
> - Fixed compilation error for JDK 1.1 (SD)

> Apache JMeter 1.1 - Feb 24 1999

> - Created the opportunity to create URL aliasing from the properties file as well as the ability to associate aliases to URL sequences instead of single URLs (SM) Thanks to Simon Chatfield for the very nice suggestions and code examples.
> - Removed the TextVisualizer and replaced it with the much more useful FileVisualizer (SM)
> - Added the known bug list (SM)
> - Removed the Java Apache logo (SM)
> - Fixed a couple of typos (SM)
> - Added UNIX makefile (SD)

> Apache JMeter 1.0.1 - Jan 25 1999

> - Removed pending issues doc issues (SM)
> - Fixed the unix script (SM)
> - Added the possibility of running the JAR directly using "java -jar ApacheJMeter.jar" with Java 2 (SM)
> - Some small updates: fixed Swing location after Java 2(tm) release, license update and small cleanups (SM)

> Apache JMeter 1.0 - Dec 15 1998

> - Initial version. (SM)

Copyright © 1999-2016, Apache Software Foundation
Apache, Apache JMeter, JMeter, the Apache feather, and the Apache JMeter logo are trademarks of the Apache Software Foundation.